//Autoren: Patrick Schaffroth, Peter Reimann
//Datum: 06.07.2004
//Programmiersprache: Java2 1.4
//Beschreibung: Das Applet fr das Schiebespielfeld.
//              Dient dazu, das Spiel ber einen Webbrowser (oder dem Appletviewer)
//              anzuschauen und zu spielen.
//              Die Spielfelder werden mit Hilfe der Klasse Schiebespielfeld
//              geladen und gemalt.
//              Das Programm greift mit Hilfe eines CGI-Skripts und des Servers
//              auf das Kit zu.

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import java.net.*;
import java.io.*;

public class Schiebesp2 extends Applet
implements ActionListener, ItemListener, MouseListener

{
   
        //Die drei Schwierigkeitsstuffen fr Spiel1
        private final int max_time = 3000;
        private final int medium_time = 2000;
        private final int min_time = 1000;

        private int inversion = 0; // Die Inversionszahl fr das Menschspielfeld
        private int zeitspanne = 1000; //Solange braucht der Computer fr einen Zug (in millisekunden)
	
        private Image image, background;
        //image wird in die Klasse Schiebespielfeld bergeben (oder fr die Highscore verwendet), background ist der Hintergrund des Applets

	private boolean akonfig; // erlaubt dem Benutzer, das Spielfeld ohne Einhaltung der Spielregeln zu mischen
	private boolean gemischt; // Kontrolle, ob gemischt wurde
	private boolean hscore; //hscore = false: Schiebespiel wird geladen
	//hscore = true: Highscore wird geladen.
        private boolean thread_is_running = false; //Zur berwachung des Threads Computerzug
	private boolean puzzlenr, sp1modus, sp2modus, mischmodus,spw,lsgmodus, warten, computerdarf, user_in_highscore, tf_visible, abbruch_modus;
	
	
	
	// Objekte, die man anklicken kann...
	//-----------------------------------
	private Button lsg,starten,hi,ok_name,sp1,sp2,btm,fertig, rmix, zumStart[], sp1_start, ja, nein, abbruch, standardfeld, zumMischen;
	private Checkbox nu;
	private TextField tf;
	private Choice chtempo;

	//-----------------------------------
	// Hier werden die Spielfelddaten gespeichert
        private Schiebespielfeld Spielfeld_computer, Spielfeld_mensch;

	//----------------------------------------------------------
	// Hier werden die Highscoredaten gespeichert
	private String hsc_name[];
	private int hsc_platz[], hsc_punkte[];
	private String name;

        //Der String, in dem der Parameter fr das aktuell geladene Image steht
        private String source = "";

	//----------------------------------------------------------
	private int empty_menschx, empty_menschy, empty_computerx, empty_computery;
        // das leere Feld von Computer und Mensch
	private int newx, newy; // das Zielfeld
	private int zaehler, compzaehler; //Zugzhler von Benutzer und Computer
        private int punkte = 0; //Die Punkte, die neu in die Highscore kommen


        //Hier werden die Loesungen abgespeichert
        public static HashMap Loesungstabelle_schiebe = new HashMap(10000);

        // Frame(s) usw.
        private Frame Fenster = new Frame("Computing a solution");
        private Dialog dialog, dialog_falseurl, dialog_noconnection, dialog_fertig, dialog_spiel1start, dialog_spiel2start, dialog_computergewonnen, dialog_menschgewonnen;
        private Panel noconnection_panel, falseurl_panel, fertig_panel, spiel1start_panel, spiel2start_panel, computergewonnen_panel, menschgewonnen_panel;

        //Image und Graphikkontext fr das Offscreen-Image beim Doublebuffering
        private Image dbImage = null;
        private Graphics dbGraphics = null;

        //Hier soll die Lsung rein
	private LinkedList Loesung = new LinkedList();


        //Serversachen
        //private final int DEFAULT_PORT = 8002;


	//-----------------------------------------------------------
	
	public void init()	
	{		
		// Initialisierung
		//--------------------------------
		// Initialisierung und Positionierung der Spielfelder
		Spielfeld_mensch = new Schiebespielfeld();
		Spielfeld_computer = new Schiebespielfeld();
		Spielfeld_mensch.setBounds(385, 90, 320, 268);
		Spielfeld_computer.setBounds(45, 90, 320, 268);
		Spielfeld_mensch.setVisible(true);
		Spielfeld_computer.setVisible(false);

		Bild_laden2(); //Laden des Hintergrundbildes
		
		// Setze leere Felder
		empty_menschx = 3;
		empty_menschy = 3;
		empty_computerx = 3;
		empty_computery = 3;
		// Startwerte
		zaehler = 0;
		compzaehler = 0;
		gemischt = false;
		mischmodus = false;
		akonfig = false;
		hscore = false;
		sp1modus = false;
		sp2modus = false;
		lsgmodus = false;
		spw = true;
		warten = false;
		computerdarf = false;
		user_in_highscore = false;
		tf_visible = false;
		abbruch_modus = true;
		puzzlenr = false;
		

		        
		setLayout(null); //das Layout wird auf null gesetzt, sonst
	        //kann man die Buttons nicht richtig positionieren
		//setBackground(Color.decode("#596f6d"));
		setBackground(Color.decode("#b7cdca"));

		//---------------------------------
		// Initialisierung der Highscore
		hsc_name = new String[20];
		hsc_platz = new int[20];
		hsc_punkte = new int[20];
		name = "";
        	lese_Highscore();

        
        //Initialisierung Buttons, Textfelder und Checkboxen
        //-----------------------------------------------
        lsg = new Button("Game III");
        starten = new Button("Back to game selection");
        hi = new Button("Highscore");
        ok_name = new Button("OK");
        fertig = new Button("Done");
        rmix = new Button("Shuffle");
        nu = new Checkbox("Numbering", puzzlenr);
        sp1 = new Button("Game I");
        sp2 = new Button("Game II");
        btm = new Button("Back to game");
	abbruch = new Button("Abort");
	standardfeld = new Button("Standard board");
        tf = new TextField("Enter your name", 8);
        chtempo = new Choice();
        
         
        //------------------------------------------------ 
        
        //Visible-Eigenschaften der Buttons, Textfelder und Checkboxen am Anfang
        //--------------------
	starten.setVisible(false);
        tf.setVisible(false);
        ok_name.setVisible(false);
        btm.setVisible(false);
        rmix.setVisible(false);
	abbruch.setVisible(false);
        hi.setVisible(false);
      	lsg.setVisible(true);
      	sp1.setVisible(true);
      	sp2.setVisible(true);
      	fertig.setVisible(false);
      	rmix.setVisible(false);
	standardfeld.setVisible(false);
        
        	
        //--------------------
        // Einfgen der Objekte
        //------------------------------
	add(starten);
	add(nu);
    	add(lsg);
    	add(hi);
    	add(ok_name); 
        add(fertig);
        add(tf);
        add(sp1);
        add(sp2);
        add(btm);
        add(rmix);
        add(chtempo);
	add(abbruch);
	add(standardfeld);
        
            		
	super.init();
		
	super.addMouseListener(this);


	//----------------------------------
	//ActionListener bzw. ItemListemer zu den Objekten hinzufgen
	starten.addActionListener(this);	
    	lsg.addActionListener(this);
    	hi.addActionListener(this);
    	ok_name.addActionListener(this);
        fertig.addActionListener(this); 
    	nu.addItemListener(this);
    	sp1.addActionListener(this);
    	sp2.addActionListener(this);
    	btm.addActionListener(this);
    	rmix.addActionListener(this);
	abbruch.addActionListener(this);
        chtempo.addItemListener(this);
	standardfeld.addActionListener(this);
		
        chtempo.add("slow");
        chtempo.add("medium");
        chtempo.add("fast");
        

        // Positionieren der Objekte (feste Position)
        //----------------------------

        chtempo.setBounds(724, 360, 100, 30);	
        chtempo.setVisible(false); 
        
        ok_name.setBounds(500,396,60,20);
        nu.setBounds(724,294,105,30);
        fertig.setBounds(724,97,105,30); 
        rmix.setBounds(724,263,105,30);                
        hi.setBounds(724,159,105,30); 
	btm.setBounds(724,300,150,30);  
        starten.setBounds(287,385,170,30);
    	sp1.setBounds(724,159,105,30);
    	sp2.setBounds(724,190,105,30);
    	lsg.setBounds(724,221,105,30);
	abbruch.setBounds(724, 128, 105, 30);
	tf.setBounds(250,396,200,30);
	standardfeld.setBounds(724, 128, 105, 30);

	
	//---------------------------------------------
	//Initialiserung und Aufbau der Dialoge
	//Intitialisierung, evtl. Layout festlegen, Positionierung, Visible-Eigenschaft, Labels (Texte) einfgen

	//Das Hauptfenster, um die Dialoge zu initialisieren
	Fenster.setVisible(false);

	//Dialog whrend die Lsung berechnet wird
	dialog = new Dialog(Fenster, "Loading");
	dialog.setBounds(350, 250, 350, 150);
	dialog.setVisible(false);
	dialog.add(new Label("Please wait a second..."));

	//Dialog, falls die URL beim Verbindungsaufbau fehlerhaft ist (Syntaxfehler, MalformeURLException)
	dialog_falseurl = new Dialog(Fenster, "Server not found", true);
	dialog_falseurl.setLayout(new GridLayout(4, 1));
	dialog_falseurl.setBounds(300, 250, 440, 160);
	dialog_falseurl.setVisible(false);
	dialog_falseurl.add(new Label("Could not connect to proxy. Please click"));
	dialog_falseurl.add(new Label("on \"Restart\" to return."));
	dialog_falseurl.add(new Label(""));

	//Dialog, falls beim Verbindungsaufbau zum Server etwas schief geht (IOException)
	dialog_noconnection = new Dialog(Fenster, "Connection failed", true);
	dialog_noconnection.setLayout(new GridLayout(4, 1));
	dialog_noconnection.setBounds(300, 250, 440, 160);
	dialog_noconnection.setVisible(false);
	dialog_noconnection.add(new Label("Could not connect to proxy. Please click"));
	dialog_noconnection.add(new Label("on \"Restart\" to return."));
	dialog_noconnection.add(new Label(""));

	//Dialog, falls der Benutzer nicht gemischt hat und trotzdem auf "Fertig" klickt
	dialog_fertig = new Dialog(Fenster, "Please shuffle the field first", true);
	dialog_fertig.setLayout(new GridLayout(4, 1));
	dialog_fertig.setBounds(300, 250, 440, 160);
	dialog_fertig.setVisible(false);
	dialog_fertig.add(new Label("You have chosen the an unmodified configuration."));
	dialog_fertig.add(new Label("Please shuffle the field before selecting Done."));
	dialog_fertig.add(new Label(""));

	//Dialog, wenn Lsung bei Spiel1 berechnet wurde
	dialog_spiel1start = new Dialog(Fenster, "Loading finished", true);
	dialog_spiel1start.setLayout(new GridLayout(4, 1));
	dialog_spiel1start.setBounds(300, 250, 440, 160);
	dialog_spiel1start.setVisible(false);
	dialog_spiel1start.add(new Label("Please click \"Start\" when you're ready."));
	dialog_spiel1start.add(new Label(""));

	//Dialog, wenn Computer bei Spiel1 gewonnen hat
	dialog_computergewonnen = new Dialog(Fenster, "Computer wins!", true);
	dialog_computergewonnen.setLayout(new GridLayout(4, 1));
	dialog_computergewonnen.setBounds(300, 250, 440, 160);
	dialog_computergewonnen.setVisible(false);
	dialog_computergewonnen.add(new Label("Alas, the computer was faster than you."));
	dialog_computergewonnen.add(new Label("Maybe next time?"));
	dialog_computergewonnen.add(new Label(""));

	//Dialog, wenn Mensch bei Spiel1 gewonnen hat
	dialog_menschgewonnen = new Dialog(Fenster, "You win!", true);
	dialog_menschgewonnen.setLayout(new GridLayout(4,1));
	dialog_menschgewonnen.setBounds(300, 250, 440, 160);
	dialog_menschgewonnen.setVisible(false);
	dialog_menschgewonnen.add(new Label("Congratulations!"));
	dialog_menschgewonnen.add(new Label("You have won against the computer. Well done!"));
	dialog_menschgewonnen.add(new Label(""));

	//Dialog, wenn Lsung bei Spiel2 berechnet wurde
	dialog_spiel2start = new Dialog(Fenster, "Loading finished", true);
	dialog_spiel2start.setBounds(300, 250, 440, 160);
	dialog_spiel2start.setVisible(false);


	//-----------------------------
	//Initialisierung der Buttons die auf die Dialoge kommen

	//Neustart-Buttons
	zumStart = new Button[4];

	for (int i = 0; i < zumStart.length; i++)
	    {    zumStart[i] = new Button("Restart");
		 zumStart[i].addActionListener(this);
	    }

	//Man kommt wieder zum Mischen, durch Klicken auf diesen Button
	zumMischen = new Button("Shuffle");
	zumMischen.addActionListener(this);


	//Starten von Spiel1
	sp1_start = new Button("Start");
	sp1_start.addActionListener(this);

	//Spiel2: Lsung soll angezeigt werden
	ja = new Button("Yes");
	ja.addActionListener(this);

	//Spiel2: Lsung soll nicht angezeigt werden
	nein = new Button("No");
	nein.addActionListener(this);


	//-----------------------------
	//Initialiesierung der Panels und Einfgen der Buttons auf sie
	//vergleiche mit den Dialogen
	//man kann einen Button nicht direkt in ein Dialog einfgen

	falseurl_panel = new Panel();
	falseurl_panel.setLayout(new FlowLayout(FlowLayout.CENTER));
	falseurl_panel.add(zumStart[0]);

	noconnection_panel = new Panel();
	noconnection_panel.setLayout(new FlowLayout(FlowLayout.CENTER));
	noconnection_panel.add(zumStart[1]);

	fertig_panel = new Panel();
	fertig_panel.setLayout(new FlowLayout(FlowLayout.CENTER));
	fertig_panel.add(zumMischen);

	computergewonnen_panel = new Panel();
	computergewonnen_panel.setLayout(new FlowLayout(FlowLayout.CENTER));
	computergewonnen_panel.add(zumStart[2]);

	menschgewonnen_panel = new Panel();
	menschgewonnen_panel.setLayout(new FlowLayout(FlowLayout.CENTER));
	menschgewonnen_panel.add(zumStart[3]);

	spiel1start_panel = new Panel();
	spiel1start_panel.setLayout(new FlowLayout(FlowLayout.CENTER));
	spiel1start_panel.add(sp1_start);

	spiel2start_panel = new Panel();
	spiel2start_panel.setLayout(new GridLayout(1, 2, 75, 0));
	spiel2start_panel.add(ja);
	spiel2start_panel.add(nein);

	//--------------------------
	//Einfgen der Panels in die zugehrigen Dialoge

	dialog_noconnection.add(noconnection_panel, BorderLayout.SOUTH);
	dialog_falseurl.add(falseurl_panel, BorderLayout.SOUTH);
	dialog_fertig.add(fertig_panel, BorderLayout.SOUTH);
	dialog_computergewonnen.add(computergewonnen_panel, BorderLayout.SOUTH);
	dialog_menschgewonnen.add(menschgewonnen_panel, BorderLayout.SOUTH);
	dialog_spiel1start.add(spiel1start_panel, BorderLayout.SOUTH);



	//Lsung fr den gelsten Zustand wird in die Hashtabelle eingefgt.
        LinkedList Fertig = new LinkedList();
        Loesungstabelle_schiebe.put(Spielfeld_mensch.hash(), Fertig.clone());
        
    	//-----------------------------

    		
	Bild_laden();	//Laden des ersten Images	       
	}
	

    //Die berladene Funktion update
        public void update(Graphics g)
        {
	    //Double-Buffer initialisieren
	    if (dbImage == null)
		{
		    dbImage = createImage(this.getSize().width, this.getSize().height);
		    dbGraphics = dbImage.getGraphics();
		}

	    //Hintergrund lschen
	    dbGraphics.setColor(getBackground());
	    dbGraphics.fillRect(0, 0, this.getSize().width, this.getSize().height);

	    //Vordergrund zeichnen
	    dbGraphics.setColor(getForeground());
	    paint(dbGraphics);

	    //Offscreen-Image anzeigen
	    g.drawImage(dbImage, 0, 0, this);

	    Untersuchung(g);
	}



    //Malfunktion
	public void paint(Graphics g)
	{

	    //Hintergrundbild malen
	    g.drawImage(background, 0, 0, this.getSize().width, this.getSize().height, this);

	    int breite, hoehe;
	    Font font;

	    FontMetrics fm = g.getFontMetrics();
	    Insets insets = getInsets();
	    breite = getSize().width;
	    hoehe = getSize().height;
	    tf.setText("Your name");

	    Spielumgebung(g, breite, hoehe, insets); //Spielumgebung um die Felder werden gemalt
	    Bilder_zeichnen(g, breite, hoehe, insets); //Die Felder oder das Highscorebild wird gemalt
	    
	    if ((sp1modus) && (mischmodus)){
		//Hier wird der Text um die Choice-Box gemalt
		int Wert;

      	        font = new Font ("Serif", Font.PLAIN, 13);
	        g.setFont(font);
      	        g.setColor(Color.white);
		g.drawString("Speed of Computer:", 720, 350);

		Wert = max_time / 1000;
		if (Wert == 1)
		    g.drawString("slow: " + String.valueOf(Wert) + " second per move", 700, 405);
		else
		    g.drawString("slow: " + String.valueOf(Wert) + " seconds per move", 700, 405);

		Wert = medium_time / 1000;
		if (Wert == 1)
		    g.drawString("medium: " + String.valueOf(Wert) + " second per move", 700, 420);
		else
		    g.drawString("medium: " + String.valueOf(Wert) + " seconds per move", 700, 420);

		Wert = min_time / 1000;
		if (Wert == 1)
		    g.drawString("fast: " + String.valueOf(Wert) + " second per move", 700, 435);
		else
		    g.drawString("fast: " + String.valueOf(Wert) + " seconds per move", 700, 435);
	    
	       if (chtempo.getSelectedItem().equals("slow"))
	       {
	           zeitspanne = max_time;
	       }
	       else if (chtempo.getSelectedItem().equals("medium"))
	       {
	    	   zeitspanne = medium_time;
	       }
	       else if (chtempo.getSelectedItem().equals("fast"))
	       {
	    	   zeitspanne = min_time;
	       }	

	    }
	    

	    Highscore(g, hscore); //Falls hscore = true, wird die Highscoretabelle gemalt
  
	
      //Spielauswahl	
      if (spw)
      {
      	font = new Font ("Serif", Font.PLAIN, 20);
	g.setFont(font);
      	g.setColor(Color.white);

      	g.drawString("Select a game", 50, 60);

      	font = new Font ("Serif", Font.BOLD, 15);
	g.setFont(font);
      
      	g.drawString("a.) Game I", 50,120);
      	g.drawString("    You and the computer", 50, 145); 
      	g.drawString("    play against each other.", 50, 170);
      	g.drawString("    Try to solve the puzzle", 50, 195); 
      	g.drawString("    faster than the computer.", 50,220);
      	g.drawString("b.) Game II", 50, 245);
      	g.drawString("    Try to find a configuration", 50, 270); 
      	g.drawString("    that is as difficult as possible.", 50, 295);
      	g.drawString("    You get a point for every move", 50, 320); 
      	g.drawString("    the computer needs for its solution.", 50,345);
      	g.drawString("c.) Game III", 50, 370);
      	g.drawString("    Play on your own (no scores).", 50, 395);
      	
      }	

      //Mischmodus: Der Benutzer hat ein Spiel gewhlt und kann jetzt das Spielfeld durchmischen
      if  (mischmodus)
      {

      	font = new Font ("Serif", Font.PLAIN, 20);
	g.setFont(font);
      	g.setColor(Color.white);

	if (lsgmodus)
	    g.drawString("Game III Shuffling Phase", 50,110);
	else if (sp1modus)
	    g.drawString("Game I Shuffling Phase", 50, 110);
	else if (sp2modus)
	    g.drawString("Game II Shuffling Phase", 50, 110);
      
      	g.drawString("Shuffle the board by clicking", 50, 140); 
      	g.drawString("on the individual pieces.", 50, 165);

	g.drawString("\"Standard board\" returns the", 50, 190);
	g.drawString("board to its initial state.", 50, 215);

	//Bei Spiel2 bleibt der Vormischen-Button verschwunden
	if (!sp2modus)
	    {
		g.drawString("Clicking on \"Shuffle\",", 50, 240);
		g.drawString("will create a random", 50, 265);
		g.drawString("configuration.", 50, 290);
	    }
 
      	inversion = Spielfeld_mensch.getInversion();//Inversionszahl, um zu bestimmen, ob es eine Lsung gibt
      	

      	if (  (((empty_menschx+1) % 2) != (inversion % 2)))
	    {
		//es gibt keine Lsung
			g.setColor(Color.red);
			g.drawString("no solution possible!", 50, 350);
			g.setColor(Color.white);
	    }

      }
	
                //Text bei Spiel3
		if  ((lsgmodus) && (!hscore) && (gemischt))
		{
		    if (Spielfeld_mensch.isSolved())
			{
			    //Spiel wurde gelst
			    g.drawString("You have solved the game.", 50, 90);
			    g.drawString("Well done!", 50, 120);
			    g.drawString("Click on \"Back", 50, 150);
			    g.drawString("to return to", 50, 180);
			    g.drawString("the menu.", 50, 210);

			}
		    else
			{
			    //Spiel ist noch nicht gelst
			    g.drawString("Ok - you can", 50, 90);
			    g.drawString("start now!", 50, 120);
			}
		}

	}	


    //Ausfhren der Buttons usw.
	public void actionPerformed(ActionEvent ae)
	{
		
	        Font font;
		Object quelle = ae.getSource();
		boolean zumStartbutton = false;

		//Bestimmung, ob einer der Neustart-Buttons auf den Dialogen gedrckt wurde
		for (int i = 0; i < zumStart.length; i++)
		    {if (quelle == zumStart[i])
			{zumStartbutton = true;
			break;
			}
	

		    }
	
		//Highscoreknopf wird gedrckt
		//alles wird vorbereitet um die Highscore anzuzeigen
		if (quelle == hi)
		{
		    //Warten bis der Computerthread zu Ende ist
		    while (thread_is_running)
			{}

			hscore = true;
			computerdarf = false;
			sp1modus = false;
			sp2modus = false;
			tf_visible = false;
			mischmodus = false;
			akonfig = false;
			
			tf.setVisible(false);
			ok_name.setVisible(false);
			sp1.setVisible(false);
			sp2.setVisible(false);
			starten.setVisible(false);
			nu.setVisible(false);
			lsg.setVisible(false);  
			hi.setVisible(false);
			abbruch.setVisible(false);
			standardfeld.setVisible(false);
			fertig.setVisible(false);
	        
	        
			Bild_laden();//Highscorebild wird geladen
			repaint();
		}

		//Button "zurck zum Spiel" in der Highscore wird gedrckt
		//Man kommt wieder von der Highscore zum Anfang des Spiels (Spielauswahl)
		if (quelle == btm)
		{			
			hscore = false;

			//Startwerte
			gemischt = false;
			mischmodus = false;
			akonfig = false;
			hscore = false;
			sp1modus = false;
			sp2modus = false;
			lsgmodus = false;
			spw = true;
			warten = false;
			computerdarf = false;
			user_in_highscore = false;
			tf_visible = false;
			abbruch_modus = true;


			// Setze leere Felder
			empty_menschx = 3;
			empty_menschy = 3;
			empty_computerx = 3;
			empty_computery = 3;
 
			zaehler = 0;
        	        compzaehler = 0;

			starten.setBounds(287,385,170,30);

			//Zurcksetzen der Spielfelder
		        Spielfeld_mensch.setBack();
			Spielfeld_computer.setBack();

			starten.setVisible(false);
			tf.setVisible(false);
			ok_name.setVisible(false);
			btm.setVisible(false);
			rmix.setVisible(false);
			abbruch.setVisible(false);
			hi.setVisible(false);
			lsg.setVisible(true);
			sp1.setVisible(true);
			sp2.setVisible(true);
			fertig.setVisible(false);
			rmix.setVisible(false);
			standardfeld.setVisible(false);

			Spielfeld_mensch.setVisible(true);
			Spielfeld_computer.setVisible(false);
	      
			nu.setVisible(true);
	        
			Bild_laden();//Bilder fr die Spielfelder wird geladen
			repaint();
		}

		//Bei der Spielauswahl wird Spiel1 gedrckt
		//bergang zum Mischmodus
		if (quelle == sp1)
		    {
			sp1.setVisible(false);
			sp2.setVisible(false);
			lsg.setVisible(false);
			starten.setVisible(true);
			fertig.setVisible(true);
			standardfeld.setVisible(true);
			rmix.setVisible(true);
			chtempo.setVisible(true);

			akonfig = true;
			mischmodus = true;
			sp1modus = true;
			spw = false;

			repaint();
		    }

		//Bei der Spielauswahl wird Spiel2 gedrckt
		//bergang zum Mischmodus
		if (quelle == sp2)
		    {

			sp1.setVisible(false);
			sp2.setVisible(false);
			lsg.setVisible(false);
			starten.setVisible(true);
			fertig.setVisible(true);
			standardfeld.setVisible(true);
			hi.setVisible(true);

			akonfig = true;
			mischmodus = true;
			sp2modus = true;
			spw = false;

			repaint();
		    }

		//Bei der Spielauswahl wird Spiel3 gedrckt
		//bergang zum Mischmodus
		if (quelle == lsg)
		    {

			sp1.setVisible(false);
			sp2.setVisible(false);
			lsg.setVisible(false);
			starten.setVisible(true);
			fertig.setVisible(true);
			rmix.setVisible(true);
			standardfeld.setVisible(true);

			akonfig = true;
			mischmodus = true;
			lsgmodus = true;
			spw = false;

			repaint();
		    }	
		

		//Beim Mischmodus wird auf den Button fertig gedrckt
		//Bei Spiel3 kann man dann das Spiel selber lsen
		//Bei Spiel2 und Spiel1 wird die Lsung berechnet	
		if (quelle == fertig)
		{
		
		    //es wird nur was gemacht, wenn eine Lsung existiert
			if (((empty_menschx+1) % 2) == (inversion % 2))
			{

			    //ist das Spielfeld nicht gemischt wird dialog_fertig angezeigt
			    if (Spielfeld_mensch.isSolved())
				{
				    dialog_fertig.setVisible(true);
				}
			    //ansonsten werden die Vorbereitungen zum Starten des Spiels getroffen
			    else
				{
				    Felderangleichen();
				    standardfeld.setVisible(false);
				    rmix.setVisible(false);
				    fertig.setVisible(false);

				    mischmodus = false;
				    akonfig = false;
				    gemischt = true;


			    //bei Spiel3 braucht man nix weiter machen
			    if (lsgmodus)
				{

				}
			    //bei Spiel1 wird die Lsung berechnet und dialog_spiel1start angezeigt
			    else if (sp1modus)
				{
				    chtempo.setVisible(false);
				    try{
					berechneLoesung();

					if (Loesung.isEmpty())
					    dialog_fertig.setVisible(true);
					else
					    {
						dialog_spiel1start.setVisible(true);
					    }

				    }
				    catch (MalformedURLException error)
					{dialog.setVisible(false);
					dialog_falseurl.setVisible(true);
					}
				    catch (IOException error)
					{dialog.setVisible(false);
					dialog_noconnection.setVisible(true);
					}

				}
			    //bei Spiel2 wird ebenfalls die Lsung berchnet dann aber dialog_spiel2start dem Ergebnis
			    //der Lsung angepasst (je nachdem ob die Anzahl der berechneten Zge fr einen
			    //Platz in der Highscore reichen) und dann noch angezeigt
			    else if(sp2modus)
				{
				    try{
				    berechneLoesung();

				    if (Loesung.isEmpty())
					dialog_fertig.setVisible(true);

				    else
					{
					    if (Loesung.size() > hsc_punkte[9])
						{
						    dialog_spiel2start.removeAll();
						    dialog_spiel2start.setLayout(null);
						    dialog_spiel2start.setLayout(new GridLayout(5,1));
						    dialog_spiel2start.add(new Label("The computer has found a solution with " + Loesung.size() + " moves."));
						    dialog_spiel2start.add(new Label("You have reached the Top 10!"));
						    dialog_spiel2start.add(new Label("Do you want to see the solution?"));
						    dialog_spiel2start.add(new Label(""));
						    dialog_spiel2start.add(spiel2start_panel);

						    user_in_highscore = true;
						}
					    else
						{
						    dialog_spiel2start.removeAll();
						    dialog_spiel2start.setLayout(null);
						    dialog_spiel2start.setLayout(new GridLayout(5,1));
						    dialog_spiel2start.add(new Label("The computer has found a solution with " + Loesung.size() + " moves."));
						    dialog_spiel2start.add(new Label("Unfortunately, this is not enough for a highscore."));
						    dialog_spiel2start.add(new Label("Do you want to see the solution?"));
						    dialog_spiel2start.add(new Label(""));
						    dialog_spiel2start.add(spiel2start_panel);

						    user_in_highscore = false;
						}

					    dialog_spiel2start.setVisible(true);
					}

				    }
		                     catch (MalformedURLException error)
			                  {dialog.setVisible(false);
                                           dialog_falseurl.setVisible(true);
			                  }
		                     catch (IOException error)
			                  {dialog.setVisible(false);
			                   dialog_noconnection.setVisible(true);
			                  }

				}

				}
			    repaint();
		  	}

		}   

		//Button "Vormischen"
		//Das Spielfeld wird mit der Funktion mischen zufllig durchgemischt
		if (quelle == rmix)
		{
			mischen();
			repaint();
		}		
		

		//Alle Buttons bei denen man wieder zur Spielauswahl kommt	  		
		if ( (quelle == starten) || (zumStartbutton) || ((quelle == nein) && (!user_in_highscore)) )
		{

		    //Warten bis der Computerthread zu Ende ist
		    while (thread_is_running)
			{}

		    //Button "zurck zur Spielauswahl" wird an die ursprngliche Position gesetzt
		    starten.setBounds(287,385,170,30);

		    chtempo.setVisible(false);
		    dialog_falseurl.setVisible(false);
		    dialog_noconnection.setVisible(false);
		    dialog_fertig.setVisible(false);
		    dialog_computergewonnen.setVisible(false);
		    dialog_menschgewonnen.setVisible(false);
		    dialog_spiel2start.setVisible(false);
		    abbruch.setLabel("abort");

		    starten.setVisible(false);
		    tf.setVisible(false);
		    ok_name.setVisible(false);
		    btm.setVisible(false);
		    rmix.setVisible(false);
		    abbruch.setVisible(false);
		    hi.setVisible(false);
		    lsg.setVisible(true);
		    sp1.setVisible(true);
		    sp2.setVisible(true);
		    fertig.setVisible(false);
		    rmix.setVisible(false);
		    standardfeld.setVisible(false);

		    Spielfeld_mensch.setVisible(true);
		    Spielfeld_computer.setVisible(false);
			    
		    //Spielfelder zurcksetzen
		    Spielfeld_mensch.setBack();
		    Spielfeld_computer.setBack();
      	
	            // Setze leere Felder
		    empty_menschx = 3;
		    empty_menschy = 3;
		    empty_computerx = 3;
		    empty_computery = 3;
	   
		    //Standardwerte
		    zaehler = 0;
		    compzaehler = 0;
		    gemischt = false;
		    mischmodus = false;
		    akonfig = false;
		    hscore = false;
		    sp1modus = false;
		    sp2modus = false;
		    lsgmodus = false;
		    spw = true;
		    warten = false;
		    computerdarf = false;
		    user_in_highscore = false;
		    tf_visible = false;
		    abbruch_modus = true;
					
			
		    Bild_laden();//Bild zur Anzeige der Spielfelder
		    repaint();
			
		}

		//Bei Spiel2: Eintrag in die Highscore
		if (quelle == ok_name)
		{
                int p;
		int position = 19; //die Position, an die der neue Eintrag kommt
                String s;
            
		tf_visible = false;
		spw = false;
		sp1modus = false;
		sp2modus = false;

	        name = tf.getText();
		//neuen Werte werden erstmal an den Schluss der Highscore gesetzt
                hsc_name[19] = name;
	        hsc_punkte[19] = punkte;

		//NeustartButton wird versetzt
		starten.setBounds(287,385,170,30);

		starten.setVisible(false);
		tf.setVisible(false);
		ok_name.setVisible(false);
		//btm.setVisible(true); //kommt spter
		rmix.setVisible(false);
		abbruch.setVisible(false);
		hi.setVisible(false);
		lsg.setVisible(false);
		sp1.setVisible(false);
		sp2.setVisible(false);
		fertig.setVisible(false);
		rmix.setVisible(false);
		nu.setVisible(false);

		abbruch.setLabel("abort");
	        
	        zaehler = 0;
	        gemischt = true;
	        
	        hscore = true;
	        	        

		//Sortierschleife, in der der neue Eintrage an die richtige Postion gesetzt wird
		//und alle anderen Eintrge darunter um einen Platz nach unten verschoben werden
		for (int i = 19; i > 0; i--)
		    {
			if (hsc_punkte[i] > hsc_punkte[i - 1])
			    {
				p = hsc_punkte[i - 1];
				s = hsc_name[i - 1];
				hsc_punkte[i - 1] = hsc_punkte[i];
				hsc_name[i - 1] = hsc_name[i];
				hsc_punkte[i] = p;
				hsc_name[i] = s;
			    }
			else
			    break;
			
			//Am Ende der Schleife steht hier dann die Postion des neuen Eintrags
			position = i;
		    }


		//Der neue Eintrag wird in die Highscoredatei highscore.dat gespeichert
               try{
		    String string = Connection("highscoreput " + position + " " + name + " " + punkte);
		    }
		    catch (MalformedURLException error)
			  {dialog.setVisible(false);
                           dialog_falseurl.setVisible(true);
			  }
		    catch (IOException error)
			  {dialog.setVisible(false);
			   dialog_noconnection.setVisible(true);
			  }
	         
	        punkte = 0;
	        	        	        
	        Bild_laden();//Highscorebild wird geladen

		btm.setVisible(true);
	        repaint();
		}

		//Starten von Spiel1
		if (quelle == sp1_start)
		    {
			dialog_spiel1start.setVisible(false);
			Spielfeld_mensch.setVisible(true);
			Spielfeld_computer.setVisible(true);
			computerdarf = true;

			repaint();
		    }

		//Spiel2: Benutzer will Lsungsweg nicht angezeigt bekommen, ist aber in der Highscore
		//der Fall, in dem der Benutzer nicht in der Highscore ist, wird an der Stelle behandelt,
		//an der auch die Neustart-Buttons behandelt werden
		if ((quelle == nein) && (user_in_highscore))
		    {
			dialog_spiel2start.setVisible(false);
			Spielfeld_mensch.setVisible(false);
			Spielfeld_computer.setVisible(true);
			punkte = Loesung.size();
			tf_visible = true;
			spw = false;

			repaint();
		    }
		 
		//Spiel2: Benutzer will Lsung angezeigt bekommen
		if (quelle == ja)
		    {
			dialog_spiel2start.setVisible(false);
			Spielfeld_mensch.setVisible(false);
			Spielfeld_computer.setVisible(true);
			punkte = Loesung.size();
			computerdarf = true;
			zeitspanne = 1000;
			abbruch.setVisible(true);

			repaint();
		    }

		//Spiel2: Anzeige der Lsung wird unterbrochen bzw. wieder fortgesetzt
		if (quelle == abbruch)
		    {
			//unterbrechen
			if (abbruch_modus)
			    {
				computerdarf = false;
				abbruch_modus = false;

				if (user_in_highscore)
				    tf_visible = true;

				while (thread_is_running)
				    {}

				abbruch.setLabel("continue");
			    }
			//fortsetzen
			else
			    {
				computerdarf = true;
				abbruch_modus = true;
				tf_visible = false;
				abbruch.setLabel("pause");
			    }

			repaint();
		    }

		//Zurcksetzen des Feldes beim Mischmodus
		if (quelle == standardfeld)
		    {
			Spielfeld_mensch.setBack();

			// Setze leere Felder
			empty_menschx = 3;
			empty_menschy = 3;
			empty_computerx = 3;
			empty_computery = 3;

			repaint();
		    }

		//Button in dialog_fertig (tritt auf, wenn das Spielfeld nicht gemischt wurde beim Drcken auf "Fertig")
		if (quelle == zumMischen)
		    {
			dialog_fertig.setVisible(false);
		    }
		
	}


    //Klicken auf die Nummerierungscheckbox usw.
	public void itemStateChanged(ItemEvent ie)
	{
		Object quelle = ie.getSource();
	
		//Nummerierungscheckbox
		//Bei allen Bildern auer dem Nummernbild wird die die Nummerierungseigenschaft
		//der Spielfelder invertiert
		if (quelle == nu)
		{
		    if (!(getParameter("src").equals("nummern.jpg")))
			{
			    puzzlenr = !puzzlenr;
			    Spielfeld_computer.setNumbering(puzzlenr);
			    Spielfeld_mensch.setNumbering(puzzlenr);

			    nu.setState(puzzlenr);

			    repaint();
			}		
		}	
	}  
    
	

        //tauscht zwei Felder aus
        //x und y bezeichnen keine absoluten Felder, sondern den Abstand zum anderen Feld		
	private void tausche(int oldx, int oldy, int x, int y)
	{
		Spielfeld_mensch.Wert[oldx][oldy] = Spielfeld_mensch.Wert[oldx + x][oldy + y];
		Spielfeld_mensch.Wert[oldx + x][oldy + y] = 15;
		empty_menschx = oldx + x;
		empty_menschy = oldy + y;
		
		Spielfeld_computer.Wert[oldx][oldy] = Spielfeld_computer.Wert[oldx + x][oldy + y];
		Spielfeld_computer.Wert[oldx + x][oldy + y] = 15;
		empty_computerx = oldx + x;
		empty_computery = oldy + y;
	}

	
        //Highscoretabelle wird gemalt	
	private void Highscore(Graphics g, boolean hscore)
	{
		Font font;
		
		if (hscore) //Highscoremodus
        {
               btm.setVisible(true);
            
            // Tabelle mit Beschriftung wird geschrieben 
            //----------------------------------------------------	
        	font = new Font ("Serif", Font.PLAIN, 35);
	    	g.setFont(font);
		g.setColor(Color.white);
	    	g.drawString ("TOP TEN", 370, 60);
	    
	    	font = new Font ("Serif", Font.PLAIN, 25);
	    	g.setFont(font);
	    	g.drawString("Name", 200, 90);
      		g.drawString("Moves", 600, 90);
       		g.setColor(Color.white);
       		
       		for (int i = 0; i <= 9; ++i)      
       		{
       			if (name.equals(hsc_name[i]))
       			{
       				g.setColor(Color.red); // Neu eingegebener Name
       				//soll mit roter Schrift erscheinen
       			} else {
       				g.setColor(Color.white);
       			}
	        if (hsc_punkte[i] > 0) //leere Eintrge haben den Wert 0
       		{

		    if (hsc_name[i].length() <= 30) //wenn Name kurz genug (hchstens 30 zeichen)
			g.drawString(hsc_name[i], 200, i*30 + 140);//Name wird komplett angezeigt

		    else //wenn Name zu lang
			g.drawString(hsc_name[i].substring(0, 29) + "...", 200, i*30 + 140);//Name wird abgeschnitten und mit 3 Punkten danach angezeigt

		    g.drawString(Integer.toString(hsc_punkte[i]), 600, i * 30 + 140);//Punkete werden gemalt

		    if (!((i > 0) && (hsc_punkte[i] == hsc_punkte[i-1])))
			g.drawString(Integer.toString(i+1) + ".)",160,i*30+140);//Platzierung wird gemalt

      		}
        	}
            // Ende der Tabelle----------------------------------------------
       } 
       g.setColor(Color.white);	// Rcksetzen der Schrift auf Wei	
	}
	

    //Zeichnen der Bilder (Spielfelder oder Highscore)
    private void Bilder_zeichnen(Graphics g, int breite, int hoehe, Insets insets)
    {

      g.setColor(Color.black);

            
      if (!hscore)
	  {
	      //Die beiden Spielfelder werden gemalt
	      Spielfeld_mensch.paint(g);
	      Spielfeld_computer.paint(g);

 	  } 
      else
	  {
 	  	if (!spw)
 	  	{
 	  	// Ansonsten wird das Highscorebild gemalt //momentan soll kein Bild gemalt werden, da es nicht sehr gut aussieht
 	  	//g.drawImage(image,150,70,this);
		}
		else
                   {;}
 	  	
 	  }
 	 	
	}


    //Diese Funktion mischt das Spielfeld zufllig durch (vgl. Button "Vormischen")
	private void mischen()
	{
		int z;
		boolean schritt; //wenn ein Schritt bereits ausgefhrt ist, dann true
		
		Random rand = new Random(System.currentTimeMillis());
		
		for (int i = 0; i <= 200; ++i)
		{
		 schritt = false;
		 
		 while (!schritt)
		 {
		 	z = Math.abs (rand.nextInt()) % 4;
		 	if (z == 0 && empty_menschx < 3)
		 	{
		 		schritt = true;
		 		tausche(empty_menschx, empty_menschy, 1, 0);
		 	} 
		 	if (z == 1 && empty_menschx >= 1)
		 	{
		 		schritt = true;
		 		tausche(empty_menschx, empty_menschy, -1, 0);
		 	}
		 	if (z == 2 && empty_menschy < 3)
		 	{
		 		schritt = true;
		 		tausche(empty_menschx, empty_menschy, 0, 1);
		 	}
		 	if (z == 3 && empty_menschy >= 1)
		 	{
		 		schritt = true;
		 		tausche(empty_menschx, empty_menschy, 0, -1);
		 	}

		 }
		}	 			 
			  			 
	}	



    //Diese Funktion malt die Umgeung um die beiden Spielfelder		
    private void Spielumgebung(Graphics g, int breite, int hoehe, Insets insets)		
    {		
	Font font;
				      	
	     
    
      //-----------------------------------------------
      if (!hscore)
      {       
        // fr Darstellung mit g.draw muss int konvertiert werden
        String zaehlerstring = Integer.toString(zaehler);
        String compzaehlerstring = Integer.toString(compzaehler);
    	

      font = new Font ("Serif", Font.PLAIN, 30);
      g.setFont(font);
      g.setColor(Color.white);

      //Spielfeldumgebung fr das Computerspielfeld
      if (Spielfeld_computer.isShown())
	  {
	      g.drawString("Computer", insets.left + 149, insets.top + 56);

	      font = new Font ("Serif", Font.PLAIN, 20);
	      g.setFont(font);

	      g.drawString("Move: ", insets.left + 168, insets.top + 391);

	      if (gemischt)
		  g.drawString(compzaehlerstring, insets.left + 232, insets.top + 391);
	      else
		  g.drawString("-", insets.left + 232, insets.top + 391);
	  }

      font = new Font ("Serif", Font.PLAIN, 30);
      g.setFont(font);
      g.setColor(Color.white);

      //Spielfeldumgebung fr das Menschspielfeld
      if (Spielfeld_mensch.isShown())
	  {
	      g.drawString("You", insets.left + 496, insets.top  + 56);

	      font = new Font ("Serif", Font.PLAIN, 20);
	      g.setFont(font);

	      g.drawString("Move: ", insets.left + 495, insets.top + 391);

	      if (gemischt)
		  g.drawString(zaehlerstring, insets.left + 560, insets.top + 391);
	      else
		  g.drawString("-", insets.left + 560, insets.top + 391);
	  }

      
    	
    	//----------------------------
        //Wenn das Eingabefenster tf (zum Eintragen in die Highscore) offen ist
	if (tf_visible)
	    {
		 starten.setBounds(700,55,170,30);
		 tf.setVisible(true);
		 ok_name.setVisible(true);
		 font = new Font ("Serif", Font.PLAIN, 18);
		 g.setFont(font);
		 g.setColor(Color.black);
		 g.fillRect(150, 364, 500,75);;
		 g.setColor(Color.red);
		 g.drawString("Congratulations! You have got a highscore!",200,383);
		 g.setColor(Color.white);
	    }
	//Wenn tf nicht offen ist
	else
	    {
		starten.setBounds(287,385,170,30);
		tf.setVisible(false);
		ok_name.setVisible(false);
	    }
 	  
      }
    }

	 
    //Diese Funktion ladet das aktuell gebrauchte Image (Spielfeldimage oder Highscoreimage)
    private void Bild_laden()
    {
	String string; //hier wird der Parameter fr das neu zu ladende Bild gesetzt
	               //dadurch wird nur dann ein Bild geladen, wenn es sich gendert hat

	boolean comp_fertig = Spielfeld_computer.isSolved();
	boolean mensch_fertig = Spielfeld_mensch.isSolved();

	if (hscore)
	    string = "hscore";//Highscoreimage
	else if ( (comp_fertig || mensch_fertig) && (gemischt))//es wird gespielt und der Mensch oder der Computer sind fertig
	    string = "srcfin";//Endbild fr das Spielfeld
	else
	    string = "src";//normales Bild fr das Spielfeld

	//ndert sich das Bild, dann wird es geladen
	if (!(string.equals(source)))
	    {
		source = string;
		image = getImage(getDocumentBase(),getParameter(source));//Imagedatei aus der HTML-Datei ziehen

		MediaTracker mt = new MediaTracker(this); //Mediatracker zur berwachung des Ladevorgangs
		mt.addImage(image, 0);

		try
		    {
			//Warten bis das Image vollstndig geladen ist
			mt.waitForAll();
		    }
		catch (InterruptedException e)
		    {
			//nothing
		    }


		//falls ntig, werden die Images in den einzelnen Spielfeldern neu gesetzt
		if (!hscore)
		    {
			if ( (comp_fertig) && (mensch_fertig) && (gemischt))//sowohl Mensch als auch Computer sind fertig
			    {
				//das Image wird in beiden Spielfeldern gesetzt(Endbild)
				Spielfeld_computer.setImage(image);
				Spielfeld_computer.setFin(true);
				Spielfeld_mensch.setImage(image);
				Spielfeld_mensch.setFin(true);
			    }
			else if ( (comp_fertig) && (gemischt))//nur der Computer ist fertig
			    {
				//das Image wird nur beim Computer gesetzt(Endbild)
				Spielfeld_computer.setImage(image);
				Spielfeld_computer.setFin(true);
			    }
			else if ( (mensch_fertig) && (gemischt))//nur der Mensch ist fertig
			    {
				//das Image wird nur beim Menschen gesetzt(Endbild)
				Spielfeld_mensch.setImage(image);
				Spielfeld_mensch.setFin(true);
			    }
			else//keiner von beiden ist fertig
			    {
				//das Spielfeld wird bei beiden gesetzt(normales Bild)
				Spielfeld_computer.setImage(image);
				Spielfeld_computer.setFin(false);
				Spielfeld_mensch.setImage(image);
				Spielfeld_mensch.setFin(false);
			    }
		    }
	    }

   }

    //Diese Funktion ladet das Hintergrundbild
    //Es wird mittels Parameter in der HTML-Datei geladen
    private void Bild_laden2()
    {
		background = getImage(getDocumentBase(),getParameter("bagr"));

		MediaTracker mt = new MediaTracker(this);
		mt.addImage(background, 0);

		try
		    {
			//Warten bis das Image vollstndig geladen ist
			mt.waitForAll();
		    }
		catch (InterruptedException e)
		    {
			//nothing
		    }
    }


   public void mouseClicked(MouseEvent event)
   {}
   public void mouseExited(MouseEvent event)
   {}
   public void mouseEntered(MouseEvent event)
   {}
   
    //drckt man den Mausbutton, wird die Postion, an der gedrckt wird mit feldx() bzw. feldy() angepasst und abgespeichert
   public void mousePressed(MouseEvent event)
      {
         
         newx = feldx(event.getX());
         newy = feldy(event.getY());
         
      }

    //lsst man die Maus wieder los,wird geprft, ob von der Stelle, auf die geklickt wurde, ein Zug mglich ist
      public void mouseReleased(MouseEvent event)
      {

	 if ((newx < 4) && (newy < 4) && (newx >= 0) && (newy >= 0))
	    {
      	 if (((!sp2modus) && (!spw)) || (mischmodus))
      	 { 
      	 if ((((Math.abs(empty_menschx - newy) == 1) &
      	    (Math.abs(empty_menschy - newx) == 0))
      	    ^
      	    ((Math.abs(empty_menschy - newx) == 1) &
	     (Math.abs(empty_menschx - newy) == 0))) | (akonfig))//Abstand zum Loch stimm, oder akonfig = true
      	 {   
	     //Zug durchfhren
      	 Spielfeld_mensch.Wert[empty_menschx][empty_menschy] 
      	 = Spielfeld_mensch.Wert[newy][newx];
      	 Spielfeld_mensch.Wert[newy][newx] = 15;
      	 empty_menschx = newy;
      	 empty_menschy = newx;
      	 
         if (!akonfig)
	     {
		 ++zaehler;
	     }


         Bild_laden();//Bild muss neu geladen werden, knnte sein, dass der Mensch fertig ist       			    	 
      	 repaint();
         }	 
         }
	    }
    	
      }	 
      	 
      	
    //gibt die relative x-Koordinate im Menschenspielfeld zurck 
      private int feldx(int x)
      {
      	Insets insets = getInsets();
	int zwischenergebniss;
	int breite = Spielfeld_mensch.getWidth() / 4;


	zwischenergebniss = (x - (Spielfeld_mensch.getLocation().x + insets.left));


	if ( (zwischenergebniss % breite) > 0)
	    return (int) zwischenergebniss / breite;
	else
	    return - 1;	
	    
      }

    //gibt die relative y-Koordinate im Menschenspielfeld zurck 
      private int feldy(int y)
      {
      	Insets insets = getInsets();
	int zwischenergebniss;
	int hoehe = Spielfeld_mensch.getHeight() / 4;


	zwischenergebniss = (y - (Spielfeld_mensch.getLocation().y + insets.top));

	if ( (zwischenergebniss % hoehe) > 0)
	    return (int) zwischenergebniss / hoehe;
	else
	    return -1;
		    
      }



    //-----------------------------------------------------------------
 

    //Einige Untersuchungen, die jedesmal beim neumalen gemacht werden mssen
    private void Untersuchung(Graphics g)
    {
	Font font;

	    //Spiel1: Mensch ist vor dem Computer fertig
	    if ((computerdarf) && (sp1modus) && (Spielfeld_mensch.isSolved()))
		{
		    computerdarf = false;  //Spiel abbrechen
		    dialog_menschgewonnen.setVisible(true);  //entsprechenden Dialog anzeigen
		}

	    //Spiel1: Computer ist vor dem Mensch fertig
	    if ((computerdarf) && (sp1modus) && (Loesung.isEmpty()) && (!dialog_menschgewonnen.isShowing()) )
		{
		    computerdarf = false;  //Spiel abbrechen
		    dialog_computergewonnen.setVisible(true);  //entsprechenden Dialog anzeigen
		}

	    //Spiel2 Lsungsanzeige: Computer ist fertig mit der Lsungsanzeige
	    if ((computerdarf) && (sp2modus) && (Loesung.isEmpty()))
		{
		    computerdarf = false;  //Spiel abbrechen
		    tf_visible = user_in_highscore;  //Wenn Benutzer in die Highscore kommt, muss das Textfield angezeigt werden

		    abbruch.setVisible(false);

		    if (!user_in_highscore) //Benutzer nicht in der Highscore
			{
      	                     font = new Font ("Serif", Font.PLAIN, 18);
	                     g.setFont(font);
			     g.setColor(Color.white);
			     g.drawString("The computer is done. Click on ", 375, 150);
                             g.drawString("\"back to game selection\"", 375, 170);
                             g.drawString("to return.", 375, 190);
			}
		    else
			repaint();
		}

	    //neuer Computerthread wird gestartet, wenn er starten darf und nicht schon luft
	    if ( (computerdarf) && (!thread_is_running))
		{
		    Thread th = new Computerzug();
		    th.start();
		}
    }

    /*Funktion encoding, um in einem String die Leerzeichen durch deren ASCII-Wert
      zu ersetzen. Wird beim aufrufen des CGI-Bentigt.*/

    private String encode(String Eingabe)
    {
	StringBuffer Ausgabe = new StringBuffer();

	for (int i = 0; i < Eingabe.length(); i++)
	    {
		if (Eingabe.charAt(i) == ' ')
		    Ausgabe.append("%20");
		else
		    Ausgabe.append(Eingabe.charAt(i));
	    }

	return Ausgabe.toString();
    }


    /*Funktion Connection um auf den Server zuzugreifen.*/

  private String ConnectionCGI(String Batch)
        throws MalformedURLException, IOException
    {

        URL url = new URL(config.cgi_location + "?" + encode(Batch));
        URLConnection con = url.openConnection();

        BufferedReader in = new BufferedReader(new InputStreamReader(con.getInputStream() ));

        String s = in.readLine();

	if (s == null)
	    {
		IOException error = new IOException();
		throw error;
	    }

        return s;

    }

  private String ConnectionDirect(String Batch)
        throws UnknownHostException, IOException
    {

        Socket client = new Socket(config.server,config.port);
        InputStream in = client.getInputStream();
        PrintStream out = new PrintStream(client.getOutputStream(), true);
        StringBuffer Eingabe = new StringBuffer();
        int Zeichen = 0;

        out.println(Batch);

        while ( true )
            {  Zeichen = in.read();
               if ( ((char) Zeichen) == '\n')
                  break;
               Eingabe = Eingabe.append((char) Zeichen);
            }

        out.close();
        in.close();
        client.close();
        return Eingabe.toString();

    }

  private String Connection(String Batch)
        throws UnknownHostException, IOException
    {
        if (config.use_cgi) {
                return ConnectionCGI(Batch);
        } else {
                return ConnectionDirect(Batch);
        }
    }


    /*Funktion die die Lsung entweder aus der Hashtabelle berechnet, oder
      vom Server holt.*/

    private void berechneLoesung()  throws MalformedURLException, IOException
    {

            int Felder[][] = new int[2][2];
	    //Loesungsliste initialisieren
	    Loesung = new LinkedList();

	    //ist Feld schon in Hashtabelle?
	    if (Loesungstabelle_schiebe.containsKey(Spielfeld_mensch.hash()))
		{
		    LinkedList temp = (LinkedList) Loesungstabelle_schiebe.get(Spielfeld_mensch.hash());
		    Loesung = (LinkedList) temp.clone();
		    //Loesung aus Hashtabelle mit dem Feld als Schlssel holen
		}

	    //ansonsten muss Server gestartet werden
	    else
		{
		    String string;
		    StringBuffer s = new StringBuffer();

		    dialog.setVisible(true);

               	    string = Connection("loesung_schiebe " + Spielfeld_mensch.hash()); //holt Lsung vom Server
		    s = new StringBuffer(string);
		    
                    //Parser des Strings s
                    while ( (s.length()) > 0)
                        {
                            Felder[0][0] = (int) s.charAt(0) - 48;
                            Felder[0][1] = (int) s.charAt(1) - 48;
                            Felder[1][0] = (int) s.charAt(3) - 48;
                            Felder[1][1] = (int) s.charAt(4) - 48;

                            s.delete(0, 6); //ersten Zug im String abschneiden
                            Loesung.add(Felder);
                            Felder = new int[2][2];
                        }

                        Loesungstabelle_schiebe.put(Spielfeld_mensch.hash(), Loesung.clone());
			//neue Lsung in Hashtabelle speichern, damit sie weiter verfgbar ist

		     dialog.setVisible(false);
	         }
    }


    /*Gleicht das Computerspielfeld an das Spielfeld des Menschen an.*/

    private void Felderangleichen()
    {
	for (int i = 0; i < 4; i++)
	    for(int j = 0; j < 4; j++)
		Spielfeld_computer.Wert[i][j] = Spielfeld_mensch.Wert[i][j];

    }


    /*Liest die Highscore aus der highscore.dat aus*/

    private void lese_Highscore()
    {
		String string = ""; //Um die Highscore einzulesen.

		try{
		    string = Connection("highscoreread"); //Verbindung zum Server
		}
		    catch (MalformedURLException error)
			  {
			  }
		    catch (IOException error)
			  {
			  }
		//Bei den Exceptions (wenn der Server nicht luft) funktioniert es noch nicht, muss man sich noch was berlegen...

		StringBuffer s = new StringBuffer(); //dient als Zwischenspeicher
                StringBuffer name = new StringBuffer(); //hier wird der aktuelle Name des Eintrags zwischengespeichert

		int j = 0; //bestimmt, an welchem Platz in der Highscore wir uns befinden

		//Parser des Strings s
		for (int i = 0; i < string.length(); i++)
		    {
			if (string.charAt(i) == ';')//Eintrag fertig
			    {
				if (s.length() == 0)
				    break;
				//Highscoredatei hat keinen Eintrag mehr.

				String s2 = s.toString().trim();
			        hsc_punkte[j] = Integer.parseInt(s2);
				hsc_platz[j] = j;
				//Punkte und Platz des Eintrags werden in die Highscore geschrieben

                                //letztes Komma lschen
                                name.deleteCharAt(name.length() - 1);

                                hsc_name[j] = name.toString();
				//Name des Eintrags wird in die Highscore geschrieben

				//Zwischenspeicher initialisieren
				s = new StringBuffer();
                                name = new StringBuffer();

				j++;
			    }
			else if (string.charAt(i) == ',')//entweder kommen jetzt die Punkte oder das Komma gehrt zum Name
			    {
				//name bekommt den aktuellen String s angehngt und s wird initialisiert
			        name = name.append(s);
                                name = name.append(","); 
         			s = new StringBuffer();
			    }
			else
			    {
				//das aktuelle Zeiche wird an s angehngt
				s = s.append(string.charAt(i));
			    }


		    }


		//die restlchen Eintrge in der Highscore (sofern es sie gibt) werden auf 0 gesetzt
		for (int i = j; i < 10; ++i)
		{
			hsc_name[i] = "no entry";
			hsc_platz[i] = i;
			hsc_punkte[i] = 0;
		}	
		//---------------------------------

    }



    //Die Klasse Computerzug ist eine Thread-Klasse, die es ermglicht, dass der Computer
    //parallel zum Menschen einen Zug macht
class Computerzug
extends Thread
{

    //Konstruktor
    public Computerzug()
    {}


    public void run()
    {
	thread_is_running = true; //Thread ist getartet


	        //warten
	        try
		{
		    Thread.sleep(zeitspanne);
		} catch (InterruptedException e) {;}


		int Felder[][] = new int[2][2];
	       
		//nchsten Zug aus der Liste holen
		Felder = (int[][]) Loesung.getFirst();
		//Zug ausfhren
		Spielfeld_computer.Wert[Felder[0][0]][Felder[0][1]] = Spielfeld_computer.Wert[Felder[1][0]][Felder[1][1]];
		Spielfeld_computer.Wert[Felder[1][0]][Felder[1][1]] = 15;

		//Zug aus der Liste lschen
		Loesung.removeFirst();

		//wenn noch weitere Zge in der Liste enthalten sind, werden diese mit dem vernderten
		//Feld als Schlssel in die Hashtabelle gespeichert. So bleiben sie immer bekannt
		if (!Loesung.isEmpty())
		    Loesungstabelle_schiebe.put(Spielfeld_computer.hash(), Loesung.clone());

		compzaehler++;

		Bild_laden();//Bild muss neu geladen werden, knnte sein, dass der Computer fertig ist 

		thread_is_running = false; //Thread ist beendet

		if (!dialog_menschgewonnen.isShowing())//wenn dieser Dialog schon steht, soll der Zug nicht mehr angezeigt werden
		    repaint();

    }
}

}      
