//Autor: Peter Reimann
//Datum: 06.07.2004
//Beschreibung: Klasse fr ein einzelnes Schiebespielfeld mit 4x4 Feldern.
//              Es wurde als Canvas implementiert, damit es die MalenFunktion
//              selbst durchfhren kann. Mann kann jedes Spielfeld auch
//              einzeln sichtbar bzw. unsichtbar machen, und die Nummering
//              aktivieren bzw. deaktiviern usw.
//              Auerdem kann man mit den Funktion setLocation(),getLocation,
//              setBounds() usw., die von der Klasse Canvas geerbt werden,
//              Die Postionen und die Gre des Spielfelds bestimmen bzw. abfragen.


import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.io.*;

public class Schiebespielfeld extends Canvas
{

    public int Wert [][] = new int[4][4];

    private Image image;
    //Das Bild mit dem das Spielfeld gemalt wird

    private Dimension Bildgroesse;
    //Groesse von image

    private boolean visible, numbering, fin;


    //Konstruktor 1
    public Schiebespielfeld()
    {
	int n = 0;

	for (int i = 0; i < 4; i++)
	    for (int j = 0; j < 4; j++)
		{
		    Wert[i][j] = n;
		    n++;
		}


	visible = true;
	numbering = false;
	fin = false;

    }


    //Konstruktor 2: Man kann zustzlich ein Image bergeben
    public Schiebespielfeld(Image image)
    {
	int n = 0;

	for (int i = 0; i < 4; i++)
	    for (int j = 0; j < 4; j++)
		{
		    Wert[i][j] = n;
		    n++;
		}

	this.image = image;
	Bildgroesse = new Dimension();
	Bildgroesse.width = image.getWidth(this);
	Bildgroesse.height = image.getHeight(this);

	visible = true;
	numbering = false;
	fin = false;

    }


    //Mit paint wird das Spielfeld gezeichnet(wer htte das gedacht?)
    public void paint(Graphics g)
    {

	int inr; //Bildnummer
	int teilbild1, teilbild2;

	//An welcher Postion und wie gro soll das Feld gemalt werden?
	Dimension Feldposition, Feldgroesse;

	Feldposition = new Dimension();
	Feldposition.width = getLocation().x;
	Feldposition.height = getLocation().y;

	Feldgroesse = new Dimension();
	Feldgroesse.width = getWidth();
	Feldgroesse.height = getHeight();

	Font font = new Font("Serif", Font.PLAIN, 20);
	g.setFont(font);

	//Wenn visible = false, wird das Feld gar nicht gezeichnet
	if (visible)
	    {
		if (fin)
		    g.drawImage(image,
				Feldposition.width,
				Feldposition.height,
				Feldgroesse.width,
				Feldgroesse.height,
				this);

		else
		for (int i = 0; i < 4; i++)
		    for (int j = 0; j < 4; j++)
			{
			    inr = Wert[i][j];

			    if ( (inr == 15))
				{
				    //Lcke zeichnen
				    g.fillRect(
					       Feldposition.width + j*(Feldgroesse.width / 4),
					       Feldposition.height + i*(Feldgroesse.height / 4),
					       Feldgroesse.width / 4,
					       Feldgroesse.height / 4
					       );

				}
			    else
				{
				    //Image darstellen
				    teilbild1 = inr / 4;
				    teilbild2 = inr % 4;
				    //-------------------------------------------------------
				    g.drawImage(
						image,
						Feldposition.width + j*(Feldgroesse.width / 4),
						Feldposition.height + i*(Feldgroesse.height / 4),
						Feldposition.width + (j + 1)*(Feldgroesse.width / 4),
						Feldposition.height + (i + 1)*(Feldgroesse.height / 4),
						teilbild2 * (Bildgroesse.width / 4),
						teilbild1 * (Bildgroesse.height / 4),
						(teilbild2 + 1) * (Bildgroesse.width / 4),
						(teilbild1 + 1) * (Bildgroesse.height / 4),
						this
						);


				    //Vierecke malen
				     g.drawRect(
					       Feldposition.width + j*(Feldgroesse.width / 4),
					       Feldposition.height + i*(Feldgroesse.height / 4),
					       Feldgroesse.width / 4,
					       Feldgroesse.height / 4
					       );


				     if (numbering)
					 {
					     //Nummerierung der Einzelbilder anzeigen
					     font = new Font("Serif", Font.BOLD, 26);
					     g.setFont(font);

					     //Das einzelne Feld ist an der richtigen Stelle => grne Farbe
					     if (inr == (i*4+j))
						 g.setColor(Color.green);
					     //Das einzelne Feld ist nicht an der richtigen Stelle => gelbe Farbe
					     else
						 g.setColor(Color.yellow);

					     g.drawString(
							  Integer.toString(inr),
							  Feldposition.width + j*(Feldgroesse.width / 4) + 35 - (inr / 10)*7,
							  Feldposition.height + i*(Feldgroesse.height / 4) + 46);
					     g.setColor(Color.black);
					 }
				}

			}
	    }
    }



    //----------------------------------------------------------------------



    //ndern der Sichtbarkeitseigenschaft
    public void setVisible(boolean visible)
    {
	this.visible = visible;
    }


    //Abfragen der Sichtbarkeitseigenschaft
    public boolean isShown()
    {
	return visible;
    }


    //Anzeigen der Nummerierung des Felds bei numbering = true
    public void setNumbering(boolean numbering)
    {
	this.numbering = numbering;
    }


    //fin bestimmt, ob bei der 15 das Loch und sonst die Vierecke gezeichnet werden oder nicht
    //wird fr gewhnlich gesetzt, wenn das Spielfeld fertig gelst ist, muss aber nicht zwingend so sein
    public void setFin(boolean fin)
    {
	this.fin = fin;
    }


    //ndern des Bildes zum Darstellen des Feldes
    public void setImage(Image image)
    {
	this.image = image;
	Bildgroesse = new Dimension();
	Bildgroesse.width = image.getWidth(this);
	Bildgroesse.height = image.getHeight(this);
    }


    //-----------------------------------------------------------------------


    //Setzt die Werte des Spielfelds wieder auf den Anfangszustand zurck
    public void setBack()
    {
	int n = 0;

	for (int i = 0; i < 4; i++)
	    for (int j = 0; j < 4; j++)
		{
		    Wert[i][j] = n;
		    n++;
		}
    }


    //Ist das Feld richtig sortiert?
    public boolean isSolved()
    {
	int n = 0;

	for (int i = 0; i < 4; i++)
	    for (int j = 0; j < 4; j++)
		{
		    if (Wert[i][j] != n)
			return false;
		    else
			n++;
		}

	return true;
    }


    //Berechnung der Inversionszahl, um zu bestimmen, ob es eine Lsung gibt
    public int getInversion()
    {
	int inversion = 0;

      	for (int i = 0; i<=14; i++)
			{	
				
					for (int j = i+1; j <=15; j++)
					{
					
					if (Wert[i / 4][i - (4 * (i / 4))] < 15) 
					{
						if (Wert[j / 4][j - (4 * (j / 4))] < 15)
						{
						  		
				    		if (Wert[i / 4][i - (4 * (i / 4))]> 
								Wert[j / 4][j - (4 * (j / 4))])
							{
								inversion++;
							}	
						}	
					}	
				}
			}

	return inversion;
    }


 /*Die Funktion hash erstellt aus dem 2-dimensionalen Spielfeld einen String,
    der entsprechend der Belegung des Feldes aus den Zahlen 0 bis 15 besteht.
    Dieser String wird bentigt um das Spielfeld in die Hashtabelle zu speichern,
    da dies nicht mit 2-dimensionalen Arrays funktioniert.*/

  public String hash()
  {
    StringBuffer Puffer = new StringBuffer();
    
    for (int i = 0; i < 4; i++)
    {
      for (int j = 0; j < 4; j++)
      {
	  if (Wert[i][j] == 15)
	      Puffer.append("0");
          else
             Puffer = Puffer.append(Wert[i][j] + 1);

        Puffer = Puffer.append(" ");
     }
    }
    return Puffer.toString();
  }

}
