import java.awt.*;
import java.applet.*;
import java.awt.event.*;
import java.util.*;
import java.net.*;
import java.io.*;

public class Solitaire extends Applet 
			implements MouseListener, ActionListener, ItemListener{
	private int x,y;
	private int rechts = 110;
	private int runter = 10;
	private int abstand = 36;
	private int abstandr = 36;
  	private Stein[][] S = new Stein[7][7];

// Zug Mglichkeiten Erkennung
	private Zugziel zugziel;
// Spielen
	private int wright = 120;

	private int nowX,nowY,nX,nY = 7;
	private boolean ausgefuert = false;
	private boolean vollesFeld = true;
	private int test =7;

// Buttons
        private Button Pruefung;
	private Button Vor;
	private Button Zurueck;
	private Button Start;
	private Button ConfigEnde;
	private Button ReConfig;
        private Button menschgewonnen_button;
        private Button noconnection_button;
	
// Geschwindigkeit
	private Choice ChTempo;

// Automatismus
	private Button AutoLauf;

// Frame(s)
        private Frame Fenster = new Frame("Computing a solution");
        private Dialog dialog, dialog_noconnection, dialog_menschgewonnen;
        private Panel menschgewonnen_panel, noconnection_panel;

//Bilder
        private Image background, SteinImage, UsetStein, MarkedStein, Pud, Prl;

//Image und Graphikkontext fr das Offscreen-Image beim Doublebuffering
        private Image dbImage = null;
        private Graphics dbGraphics = null;

// Zge Zurcknehmen
	private ArrayList ZugListe = new ArrayList();

/*Hier soll die Lsung rein*/
	private int Felder [][] = new int [3][2];
	private LinkedList Loesung = new LinkedList();

// Kontrolle
    	private boolean be = true;
	private boolean SetMode = true;
	private boolean original = true;
	private boolean CDarf = false;
	private boolean AutoL = false;
	private boolean ConfigAufbau = false;
	private int sleeper = 0; //Zeit zwischen Zgen
        private int dauer = 0; //Zeit, die der Computer zum Berechnen der Lsung braucht.

        private HashMap Loesungstabelle_sol = new HashMap(10000);
  /*Hier werden die Loesungen abgespeichert, muss global definiert werden.*/

        private boolean nohost = false;
        private boolean noconnection = false;
        private boolean fertig = false;
        private boolean keine_loesung = false;
        private boolean loesung_existiert = false;
        private boolean menschgewonnen = false;
	
	
	public void init() {
		setLayout(null);
		setBackground(Color.white); //Hintergrund 

		Bild_Laden();

		StartFeldInit();
		nachb();
		this.addMouseListener(this);

		//Buttons
		ConfigEnde = new Button("Done");
		ConfigEnde.setBounds(270+wright,150,120,30);
		add(ConfigEnde);
		ConfigEnde.addActionListener(this);
		
		ReConfig = new Button("Reconfigure");
		ReConfig.setBounds(55+wright,320,120,30);
		ReConfig.addActionListener(this);


                Pruefung = new Button("Solution?");
                Pruefung.setBounds(270+wright,120,120,30);
                Pruefung.addActionListener(this);

		Vor = new Button("Next move");
		Vor.setBounds(270+wright,80,120,30);
		Vor.addActionListener(this);
		
		Zurueck = new Button("Undo move");
		Zurueck.setBounds(270+wright,160,120,30);
		Zurueck.addActionListener(this);

		Start = new Button("Standard board");
		Start.setBounds(55+wright,280,120,30);
		add(Start);
		Start.addActionListener(this);

		ChTempo = new Choice();
		add(ChTempo);
		ChTempo.add("fast");
		ChTempo.add("medium");
		ChTempo.add("slow");
		ChTempo.setBounds(270+wright,320,120,30);
		ChTempo.addItemListener(this);
		ChTempo.setVisible(false);

		AutoLauf = new Button("Show solution");
		AutoLauf.setBounds(270+wright,360,120,30);
		AutoLauf.addActionListener(this);

		//add(AutoLauf);

		Fenster.setVisible(false);
		dialog = new Dialog(Fenster, "Computing a solution");
		dialog.setBounds(350, 250, 350, 150);
		dialog.setVisible(false);
		dialog.setLayout(new GridLayout(3,1));
		dialog.add(new Label("Please wait while the computer computes a solution..."));
		dialog.add(new Label("Time: " + dauer + " seconds"));

		dialog_menschgewonnen = new Dialog(Fenster, "You have solved the game.", true);
		dialog_menschgewonnen.setLayout(new GridLayout(4, 1));
		dialog_menschgewonnen.setBounds(350, 250, 350, 150);
		dialog_menschgewonnen.add(new Label("Congratulations!"));
		dialog_menschgewonnen.add(new Label("You have solved the game. Well done!"));
		dialog_menschgewonnen.add(new Label(""));

		//Dialog, falls beim Verbindungsaufbau zum Server etwas schief geht (IOException)
		dialog_noconnection = new Dialog(Fenster, "Connection failed", true);
		dialog_noconnection.setLayout(new GridLayout(4, 1));
		dialog_noconnection.setBounds(350, 250, 440, 160);
		dialog_noconnection.setVisible(false);
		dialog_noconnection.add(new Label("Could not connect to proxy. Please click"));
		dialog_noconnection.add(new Label("on \"Back\" to return."));
		dialog_noconnection.add(new Label(""));

		menschgewonnen_button = new Button("Restart");
		menschgewonnen_button.addActionListener(this);

		menschgewonnen_panel = new Panel();
		menschgewonnen_panel.setLayout(new FlowLayout(FlowLayout.CENTER));
		menschgewonnen_panel.add(menschgewonnen_button);

		dialog_menschgewonnen.add(menschgewonnen_panel);
		dialog_menschgewonnen.setVisible(false);

		noconnection_button = new Button("Back");
		noconnection_button.addActionListener(this);

		noconnection_panel = new Panel();
		noconnection_panel.setLayout(new FlowLayout(FlowLayout.CENTER));
		noconnection_panel.add(noconnection_button);

		dialog_noconnection.add(noconnection_panel);
		dialog_noconnection.setVisible(false);


		FeldListInit(); //Anfangskonfiguration in Zugliste einfgen


    		boolean Feld_fertig[][] = {{false, false, false, false, false, false, false},
                               		   {false, false, false, false, false, false, false},
                               		   {false, false, false, false, false, false, false},
                               		   {false, false, false, true, false, false, false},
                               		   {false, false, false, false, false, false, false},
                               		   {false, false, false, false, false, false, false},
                               		   {false, false, false, false, false, false, false}};
                 LinkedList Fertig = new LinkedList();
                 Loesungstabelle_sol.put(hash(Feld_fertig), Fertig);


	}


    //Die berladene Funktion update
        public void update(Graphics g)
        {
	    //Double-Buffer initialisieren
	    if (dbImage == null)
		{
		    dbImage = createImage(this.getSize().width, this.getSize().height);
		    dbGraphics = dbImage.getGraphics();
		}

	    //Hintergrund lschen
	    dbGraphics.setColor(getBackground());
	    dbGraphics.fillRect(0, 0, this.getSize().width, this.getSize().height);

	    //Vordergrund zeichnen
	    dbGraphics.setColor(getForeground());
	    paint(dbGraphics);

	    //Offscreen-Image anzeigen
	    g.drawImage(dbImage, 0, 0, this);

	    Untersuchung();
	}


	public void paint(Graphics g) {
		
	    g.drawImage(background, 0, 0,this.getSize().width, this.getSize().height, this);

	    Font font = new Font("Serif", Font.BOLD, 14);
	    g.setFont(font);
		
		for(int i=0; i<=6; i++)
			for(int j=0; j<=6; j++)
			  if (!S[i][j].empty)
				S[i][j].anzeigen(g);
		for (int i=0; i<=6; i++)
			for (int j=0; j<=6; j++)
			  if (!S[i][j].empty)
			    if (!(S[i][j].pfeil == 0))
				S[i][j].anzeigen(g);

		//Test
		/* g.drawString("Inhalt in ZugListe: " + (ZugListe.size()) ,80,300); */
		//TEST	

		if (ChTempo.getSelectedItem().equals("fast"))	  
			sleeper = 0;
		else if (ChTempo.getSelectedItem().equals("medium"))
			sleeper = 1;
		else if (ChTempo.getSelectedItem().equals("slow"))
			sleeper = 2;

		if (SetMode)
		    {
			g.drawString("Configuration phase: You can insert or remove", 40, 380);
			g.drawString("pieces by clicking on the holes or pegs", 40, 395);
			g.drawString("Click on \"Done\" when you're ready,", 40, 410);
			g.drawString("to start the game. Clicking on", 40, 425);
			g.drawString("\"Standard board\" restores the default configuration", 40, 440);
		    }

		g.setFont(font); //wei nicht, warum man das hier nochmal machen muss
		                 //aber ohne gehts anscheinend net

		if(fertig)
		    {g.drawString("The game is solved.", 70, 420);}

		if(keine_loesung)
		    {g.drawString("There is no solution.", 70, 420);}

		if (loesung_existiert)
		    {g.drawString("There is a solution. Click on \"Next Move\" to", 20, 420);
		     g.drawString("see it.", 20, 435);}

		if (nohost)
		    {g.drawString("Could not find server.", 50, 420);
		     nohost = false;}

		if (noconnection)
		    {g.drawString("Connection to server failed.", 50, 420);
		     noconnection = false;}

	}

	private void StartFeldInit(){
	for(int i=0; i<=6; i++)
	    for(int j=0; j<=6; j++)
			  if (i==3 && j==3){  //Hier leeres Feld
				S[i][j] = new Stein(i*abstand+rechts, j*abstandr+runter);
				S[i][j].empty = false;
				S[i][j].setImage(SteinImage, UsetStein, MarkedStein, Pud, Prl);
			  }
			  else
			  if (!((i==0||i==1||i==5||i==6) && (j==0||j==1||j==5||j==6)))
			      {
				S[i][j] = new Stein(i*abstand+rechts, j*abstandr+runter, true);	
				S[i][j].setImage(SteinImage, UsetStein, MarkedStein, Pud, Prl);
			      }
			  else
			      {
				S[i][j] = new Stein(i*abstand+rechts, j*abstandr+runter);
				S[i][j].setImage(SteinImage, UsetStein, MarkedStein, Pud, Prl);
			      }

	}
	
	private void FeldListInit(){
		boolean Feld[][] = new boolean[7][7];

                for(int m=0; m<=6; m++)
                    for(int n=0; n<=6; n++)
                        if (!S[m][n].empty)
                              Feld[m][n] = S[m][n].gesetzt;
		ZugListe.clear();
                ZugListe.add(Feld);
	}	
  	private void FeldUmarkieren(){
		for(int m=0; m<=6; m++)
                    for(int n=0; n<=6; n++)
			if (!S[m][n].empty)
				S[m][n].umarkieren();
	}

	private void FeldClear(){
		for(int m=0; m<=6; m++)
		    for(int n=0; n<=6; n++)
			if (!S[m][n].empty){
				S[m][n].umarkieren();
				S[m][n].pfeil = 0;
				S[m][n].noZiel();
			}				
	}



    /*Funktion Connection um auf den Server zuzugreifen.*/

  private String ConnectionCGI(String Batch)
	throws MalformedURLException, IOException
    {

        URL url = new URL(config.cgi_location + "?" + encode(Batch));
        URLConnection con = url.openConnection();

        BufferedReader in = new BufferedReader(new InputStreamReader(con.getInputStream() ));

	String s = in.readLine();

	if (s == null)
	    {
		IOException error = new IOException();
		throw error;
	    }
        
	return s;

    }

  private String ConnectionDirect(String Batch)
	throws UnknownHostException, IOException
    {

        Socket client = new Socket(config.server,config.port);
        InputStream in = client.getInputStream();
        PrintStream out = new PrintStream(client.getOutputStream(), true);
        StringBuffer Eingabe = new StringBuffer();
        int Zeichen = 0;

        out.println(Batch);

        while ( true )
            {  Zeichen = in.read();
               if ( ((char) Zeichen) == '\n')
                  break;
               Eingabe = Eingabe.append((char) Zeichen);
            }

        out.close();
        in.close();
        client.close();
        return Eingabe.toString();

    }

  private String Connection(String Batch)
	throws UnknownHostException, IOException
    {
	if (config.use_cgi) {
		return ConnectionCGI(Batch);
	} else {
		return ConnectionDirect(Batch);
	}
    }
  


   /*Die Funktion hash erstellt aus dem 2-dimensionalen Spielfeld einen String,
    der entsprechend der Belegung des Feldes aus 0en bzw. 1en besteht.
    Dieser String wird bentigt um das Spielfeld in die Hashtabelle zu speichern,
    da dies nicht mit 2-dimensionalen Arrays funktioniert.*/

  private String hash(boolean Feld[][])
  {
    StringBuffer Puffer = new StringBuffer();
    
    for (int i = 0; i < 7; i++)
    {
      for (int j = 0; j < 7; j++)
      {
        if (Feld[i][j]) Puffer = Puffer.append("1 ");
        else Puffer = Puffer.append("0 ");
      }
    }
    return Puffer.toString();
  }


    /*Funktion encoding, um in einem String die Leerzeichen durch deren ASCII-Wert
      zu ersetzen. Wird beim aufrufen des CGI-Bentigt.*/

    private String encode(String Eingabe)
    {
	StringBuffer Ausgabe = new StringBuffer();

	for (int i = 0; i < Eingabe.length(); i++)
	    {
		if (Eingabe.charAt(i) == ' ')
		    Ausgabe.append("%20");
		else
		    Ausgabe.append(Eingabe.charAt(i));
	    }

	return Ausgabe.toString();
    }


	//Nachbarn fr Sprnge herausfinden
	public void nachb (){
		Zugziel z;

		for(int i=0; i<=6; i++)
			for(int j=0; j<=6; j++)
				if (!S[i][j].empty){
					if ((i+2)<=6)
						if (!(S[i+2][j] == null)){
							z = new Zugziel(i+2, j, i+1, j);
							S[i][j].ziel.add(z);
						}
					if ((i-2)>=0)
						if (!(S[i-2][j] == null)){
							z = new Zugziel(i-2, j, i-1, j);
							S[i][j].ziel.add(z);
						}
					if ((j+2)<=6)
						if (!(S[i][j+2] == null)){
							z = new Zugziel(i, j+2, i, j+1);
							S[i][j].ziel.add(z);
						}
					if ((j-2)>=0)
						if (!(S[i][j-2] == null)){
							z = new Zugziel(i, j-2, i, j-1);
							S[i][j].ziel.add(z);
						}		
	      				
			  	}
	}

    
    private void computerzug(int Felder[][])
    {

	// Pause vor anzeige des Computer Zug
	try {
		if (sleeper == 0)
			Thread.sleep(500);
		if (sleeper == 1)
			Thread.sleep(1000);
		if (sleeper == 2)
			Thread.sleep(1500);
	}
	catch (InterruptedException e) {
		System.err.println("Exception during sleep()");
		}

	boolean[][] Feld = {{false, false, false, false, false, false, false},
			    {false, false, false, false, false, false, false},
			    {false, false, false, false, false, false, false},
			    {false, false, false, false, false, false, false},
			    {false, false, false, false, false, false, false},
			    {false, false, false, false, false, false, false},
			    {false, false, false, false, false, false, false}};
			    
	S[Felder[0][0]][Felder[0][1]].gesetzt = false;
	S[Felder[0][0]][Felder[0][1]].umarkieren();
	S[Felder[1][0]][Felder[1][1]].gesetzt = false;
	S[Felder[2][0]][Felder[2][1]].noZiel();
	S[Felder[2][0]][Felder[2][1]].gesetzt = true;


	for(int m=0; m<=6; m++)
		for(int n=0; n<=6; n++)
			if (!S[m][n].empty)
			    {
				Feld[m][n] = S[m][n].gesetzt;
				S[m][n].pfeil = 0;
			    }

	ZugListe.add(Feld);
	Loesung.removeFirst();

	if (!Loesung.isEmpty())
	  Loesungstabelle_sol.put(hash(Feld), Loesung.clone());
	else
	    {
		remove(Vor);
		AutoL = false;
		remove(AutoLauf);
		ChTempo.setVisible(false);
		loesung_existiert = false;
		fertig = true;
	    }

	repaint();

    }

    private void TM (int Felder[][]){
	
	S[Felder[0][0]][Felder[0][1]].markieren();
	S[Felder[2][0]][Felder[2][1]].isZiel();

	if (Felder[0][0] == Felder[2][0]){
		if (Felder[0][1] < Felder[2][1])
			S[Felder[1][0]][Felder[1][1]].pfeil = 4;
		if (Felder[0][1] > Felder[2][1])
			S[Felder[1][0]][Felder[1][1]].pfeil = 3;
	}else{
		if (Felder[0][0] > Felder[2][0])
			S[Felder[1][0]][Felder[1][1]].pfeil = 2;
		if (Felder[0][0] < Felder[2][0])
			S[Felder[1][0]][Felder[1][1]].pfeil = 1;
	}
	repaint();
     }


    private boolean istFertig()
    {
	for (int i = 0; i < 7; i++)
	    for(int j = 0; j < 7; j++)
		{if (!S[i][j].empty){
                    if ( (i == 3) && (j == 3))
		       {if (S[i][j].gesetzt == false)
			   return false;}
		    else
		       {if (S[i][j].gesetzt == true)
			   return false;}
		}
		}

	return true;

    }



	public void zug() {
		boolean erfolg= false;
		boolean[][] Feld = {{false, false, false, false, false, false, false},
			            {false, false, false, false, false, false, false},
			            {false, false, false, false, false, false, false},
			            {false, false, false, false, false, false, false},
			            {false, false, false, false, false, false, false},
			            {false, false, false, false, false, false, false},
			            {false, false, false, false, false, false, false}};


		
		if ((nowX <= 6)&&(nowY <= 6)){
			for (int i=1; i <= S[nowX][nowY].ziel.size(); i++){
				zugziel = (Zugziel) S[nowX][nowY].ziel.get(i-1);
				if ((zugziel.zielx == nX)&&(zugziel.ziely == nY)&&
				     (S[zugziel.zwischenx][zugziel.zwischeny].gesetzt)){	
					erfolg = true;
					S[nowX][nowY].uset();
					S[zugziel.zwischenx][zugziel.zwischeny].uset();
					S[nX][nY].set();
					S[nX][nY].umarkieren(); //dass nach hpfen keine markierung
					//nowX = nX; wenn Markierung mit hpfen soll
					//nowY = nY;

				for(int m=0; m<=6; m++) //In Booleanliste die gesetzten Steine bertragen
					for(int n=0; n<=6; n++)
						if (!S[m][n].empty)
							Feld[m][n] = S[m][n].gesetzt;

				ZugListe.add(Feld);
				
				}
			}

		    /*ist Feld schon in Hashtabelle?*/
		    if (Loesungstabelle_sol.containsKey(hash(Feld)))
			{
			    LinkedList temp = (LinkedList) Loesungstabelle_sol.get(hash(Feld));
			    Loesung = (LinkedList) temp.clone();
                            int Felder[][] = new int[3][2];

		            if (Loesung.isEmpty())
			        {menschgewonnen = true;
                                 loesung_existiert = false;
                                 keine_loesung = false;
                                 remove(Vor);
				 
				 AutoL =false;
				 remove(AutoLauf);

				 ChTempo.setVisible(false);}
                            else
                            {
		               Felder = (int[][]) Loesung.getFirst();

		               if ( (Felder[0][0] == 0) && (Felder[0][1] == 0) && (Felder[1][0] == 0) &&
			            (Felder[1][1] == 0) && (Felder[2][0] == 0) && (Felder[2][1] == 0))
			              {keine_loesung = true;
                                       loesung_existiert = false;
                                       fertig = false;
                                       remove(Vor);
				       AutoL = false;
				       remove(AutoLauf);
				       ChTempo.setVisible(false);}
		               else
			       {
			           loesung_existiert = true;
				   keine_loesung = false;
				   fertig = false;
			           add(Vor);
				   add(AutoLauf);
				   ChTempo.setVisible(true);

			       }
			    }


			}
		    else
			{
		           remove(Vor);
			   AutoL = false;
			   remove(AutoLauf);
			   ChTempo.setVisible(false);
		           loesung_existiert = false;
		           keine_loesung = false;
		           fertig = false;
		           Loesung = new LinkedList();		

		           fertig = istFertig();
			   Loesen();
			}
		}
	}


	
	public void mouseClicked (MouseEvent e){
		int x = e.getX();
		int y = e.getY();
		boolean made = false;
		be = true;
		
		if (SetMode){
			for(int i=0; i<=6; i++)
		  	  for(int j=0; j<=6; j++)
			  	if (!S[i][j].empty){
			      		
					made=S[i][j].klicked(x,y);
					S[i][j].umarkieren();
					if (made){
						if (S[i][j].gesetzt)
							S[i][j].uset();
						else
							S[i][j].set();
					}
				}
		}
		else{
			boolean drin = false;
                	boolean out = false;
                        boolean markiert = false;

			for(int i=0; i<=6; i++) //Alles Rcksetzen und weiter ..
		  	  for(int j=0; j<=6; j++)
			  	if (!S[i][j].empty){

                                        if (!markiert)
                                            markiert = S[i][j].ismarkiert();

				        S[i][j].noZiel();
				        S[i][j].umarkieren();
					S[i][j].pfeil = 0; 
			      		if(!drin)
				  	  drin = S[i][j].isIn(x, y);

					ausgefuert =S[i][j].klicked(x,y); //ausgefuert erkennung ob berhautpt ein feld angeklickt wurde marker gesetzt

                                	if ((!out) && (ausgefuert))
                                   		out = true;

			        	if (ausgefuert){
					    vollesFeld = S[i][j].gesetzt;
				  		if (vollesFeld){
							nowX = i;
				  			nowY = j;
				  		}else{
							nX = i;
							nY = j;
				  		}  
					}
			  	}
			if (!drin){
		    		nowX = 7;
		     		nowY = 7;
			}


			if ((!vollesFeld) && (out) && (markiert))
				zug(); //Bedingung fr add(Vor) muss ausserdem sein wenn, wenn beim zug das ziel ausserhalb ist und nichts passiert
		}
			repaint();
	}	


	public void mouseReleased(MouseEvent e){
	}
	public void mousePressed(MouseEvent e){
	}
	public void mouseEntered(MouseEvent e){
	}
	public void mouseExited(MouseEvent e){
	}
	//Button

	private void Loesen(){
		boolean[][] Feld = {{false, false, false, false, false, false, false},
			            {false, false, false, false, false, false, false},
			            {false, false, false, false, false, false, false},
			            {false, false, false, false, false, false, false},
		        	    {false, false, false, false, false, false, false},
			            {false, false, false, false, false, false, false},
			            {false, false, false, false, false, false, false}};


		    Feld = (boolean[][]) ZugListe.get(ZugListe.size() - 1);
                    int Felder[][] = new int[3][2];

		    /*Loesungsliste initialisieren*/
		    Loesung = new LinkedList();

		    /*ist Feld schon in Hashtabelle?*/
		    if (Loesungstabelle_sol.containsKey(hash(Feld)))
			{
			    LinkedList temp = (LinkedList) Loesungstabelle_sol.get(hash(Feld));
			    Loesung = (LinkedList) temp.clone();
			}

		    /*ansonsten muss Server gestartet werden.*/
		    
                    if (!Loesung.isEmpty())
                       {
		       Felder = (int[][]) Loesung.getFirst();

		       if ( (Felder[0][0] == 0) && (Felder[0][1] == 0) && (Felder[1][0] == 0) &&
			    (Felder[1][1] == 0) && (Felder[2][0] == 0) && (Felder[2][1] == 0))
			   {keine_loesung = true;}
		       else
			   {
			       loesung_existiert = true;
			       add(Vor);
			       add(AutoLauf);
			       ChTempo.setVisible(true);
			   }
		       }
                    }

		          

	public void actionPerformed(ActionEvent e){

		boolean[][] Feld = {{false, false, false, false, false, false, false},
			            {false, false, false, false, false, false, false},
			            {false, false, false, false, false, false, false},
			            {false, false, false, false, false, false, false},
		        	    {false, false, false, false, false, false, false},
			            {false, false, false, false, false, false, false},
			            {false, false, false, false, false, false, false}};

		if (e.getSource() == ConfigEnde){
			add(Pruefung);
			add(Zurueck);
			add(ReConfig);
			remove(ConfigEnde);
			
			original=false;
			Start.setLabel("Restart");

			SetMode = false;
			FeldListInit();	

			Feld = (boolean[][]) ZugListe.get(0);

		    /*ist Feld schon in Hashtabelle?*/
		    if (Loesungstabelle_sol.containsKey(hash(Feld)))
			{
			    LinkedList temp = (LinkedList) Loesungstabelle_sol.get(hash(Feld));
			    Loesung = (LinkedList) temp.clone();
                            int Felder[][] = new int[3][2];

		            if (Loesung.isEmpty())
			        {fertig = true;
                                 loesung_existiert = false;
                                 keine_loesung = false;
                                 remove(Vor);
				 AutoL = false;
				 remove(AutoLauf);
				 ChTempo.setVisible(false);
				}
                            else
                            {
		               Felder = (int[][]) Loesung.getFirst();

		               if ( (Felder[0][0] == 0) && (Felder[0][1] == 0) && (Felder[1][0] == 0) &&
			            (Felder[1][1] == 0) && (Felder[2][0] == 0) && (Felder[2][1] == 0))
			              {keine_loesung = true;
                                       loesung_existiert = false;
                                       fertig = false;
                                       remove(Vor);
				       AutoL = false;
				       remove(AutoLauf);
				       ChTempo.setVisible(false);}
		               else
			       {
			           loesung_existiert = true;
				   keine_loesung = false;
				   fertig = false;
			           add(Vor);
				   add(AutoLauf);
				   ChTempo.setVisible(true);
			       }
			    }


			}
		    else
			{
			    remove(Vor);
			    AutoL = false;
			    remove(AutoLauf);
			    ChTempo.setVisible(false);
			    loesung_existiert = false;
			    keine_loesung = false;
			    fertig = false;
			}
		}
		

		if (e.getSource() == ReConfig) {
			remove (Pruefung);
			remove (Zurueck);
			remove (ReConfig);
			remove(Vor);
			AutoL = false;
			remove(AutoLauf);
			ChTempo.setVisible(false);
			add(ConfigEnde);

			original=true;
			Start.setLabel("Standard board");
			
			SetMode = true;
			fertig = false;
			loesung_existiert = false;
			keine_loesung = false;

			be = true;

			for(int i=0; i<=6; i++)
		  	  for(int j=0; j<=6; j++)
			  	if (!S[i][j].empty){
					S[i][j].noZiel();
					S[i][j].umarkieren();
					S[i][j].pfeil = 0;
				}
		}
		
		
		if (e.getSource() == Zurueck)
			{
               		 be = true;

		  	 for(int i=0; i<=6; i++)
		  	   for(int j=0; j<=6; j++)
			   	 if (!S[i][j].empty){
					 S[i][j].noZiel();
					 S[i][j].umarkieren();}

                          if ( ZugListe.size() > 1  )
                          {				
			  Feld = (boolean[][]) ZugListe.get(ZugListe.size() - 2);

			  for(int m=0; m<=6; m++)
					for(int n=0; n<=6; n++)
                                                {
						if (!S[m][n].empty)
                                                   {
							S[m][n].gesetzt = Feld[m][n];
							S[m][n].umarkieren();
							S[m][n].pfeil = 0;
                                                   }
						}
			    ZugListe.remove(ZugListe.size() - 1);
			  

		    /*ist Feld schon in Hashtabelle?*/
		    if (Loesungstabelle_sol.containsKey(hash(Feld)))
			{
			    LinkedList temp = (LinkedList) Loesungstabelle_sol.get(hash(Feld));
			    Loesung = (LinkedList) temp.clone();
                            int Felder[][] = new int[3][2];

		            if (Loesung.isEmpty())
			        {fertig = true;
                                 loesung_existiert = false;
                                 keine_loesung = false;
                                 remove(Vor);
				 AutoL = false;
				 remove(AutoLauf);
				 ChTempo.setVisible(false);}
                            else
                            {
		               Felder = (int[][]) Loesung.getFirst();

		               if ( (Felder[0][0] == 0) && (Felder[0][1] == 0) && (Felder[1][0] == 0) &&
			            (Felder[1][1] == 0) && (Felder[2][0] == 0) && (Felder[2][1] == 0))
			              {keine_loesung = true;
                                       loesung_existiert = false;
                                       fertig = false;
                                       remove(Vor);
				       AutoL = false;
				       remove(AutoLauf);
			  	       ChTempo.setVisible(false);}
		               else
			       {
			           loesung_existiert = true;
				   keine_loesung = false;
				   fertig = false;
			           add(Vor);
				   add(AutoLauf);
				   ChTempo.setVisible(true);
			       }
			    }


			}
		    else
			{
			    remove(Vor);
			    AutoL = false;
			    remove(AutoLauf);
			    ChTempo.setVisible(false);
			    loesung_existiert = false;
			    keine_loesung = false;
			    fertig = false;
			}
			}
			} 

		if (e.getSource() == noconnection_button)
		    {
			dialog_noconnection.setVisible(false);
		    }


		if ((e.getSource() == Start) || (e.getSource() == menschgewonnen_button))
		    {
			dialog_menschgewonnen.setVisible(false);
			menschgewonnen = false;

			if (original){
				for(int m=0; m<=6; m++)
					for(int n=0; n<=6; n++){
						if (!S[m][n].empty){
							S[m][n].set();
							S[m][n].umarkieren();
						}
						if (m==3 && n==3){
							S[m][n].uset();
							S[m][n].umarkieren();
						}
					}
			}
			else{
               		     be = true;

		  	     for(int i=0; i<=6; i++)
		  	       for(int j=0; j<=6; j++)
			   	    if (!S[i][j].empty){
					    S[i][j].noZiel();
					    S[i][j].umarkieren();
					    S[i][j].pfeil = 0;
				    }

				if (!(ZugListe.isEmpty())){
			  		Feld = (boolean[][]) ZugListe.get(0);
			    		for(int m=0; m<=6; m++)
						for(int n=0; n<=6; n++)
							if (!S[m][n].empty){
								S[m][n].gesetzt = Feld[m][n];
								S[m][n].umarkieren();
							}
			    		ZugListe.subList(1, ZugListe.size()).clear();

		                        /*ist Feld schon in Hashtabelle?*/
		                        if (Loesungstabelle_sol.containsKey(hash(Feld)))
			                {
			                     LinkedList temp = (LinkedList) Loesungstabelle_sol.get(hash(Feld));
			                     Loesung = (LinkedList) temp.clone();
                                             int Felder[][] = new int[3][2];

		                             if (Loesung.isEmpty())
			                     {fertig = true;
                                             loesung_existiert = false;
                                             keine_loesung = false;
                                             remove(Vor);
					     AutoL = false;
					     remove(AutoLauf);
					     ChTempo.setVisible(false);}
                                             else
                                            {
		                                 Felder = (int[][]) Loesung.getFirst();

		                                 if ( (Felder[0][0] == 0) && (Felder[0][1] == 0) && (Felder[1][0] == 0) &&
			                              (Felder[1][1] == 0) && (Felder[2][0] == 0) && (Felder[2][1] == 0))
			                              {keine_loesung = true;
                                                       loesung_existiert = false;
                                                       fertig = false;
                                                       remove(Vor);
						       AutoL = false;
						       remove(AutoLauf);
						       ChTempo.setVisible(false);}
		                                 else
			                         {
			                             loesung_existiert = true;
				                     keine_loesung = false;
				                     fertig = false;
			                             add(Vor);
						     add(AutoLauf);
						     ChTempo.setVisible(true);
			                         }
					    }


					}
		                        else
			                {
			                    remove(Vor);
					    AutoL = false;
					    remove(AutoLauf);
					    ChTempo.setVisible(false);
			                    loesung_existiert = false;
			                    keine_loesung = false;
			                    fertig = false;
					}
				}
			}
		}

		if (e.getSource() == Pruefung)
		    {
			Zeitzaehlthread th = new Zeitzaehlthread();
                    try {
		    Feld = (boolean[][]) ZugListe.get(ZugListe.size() - 1);
                    int Felder[][] = new int[3][2];

		    /*Loesungsliste initialisieren*/
		    Loesung = new LinkedList();

		    /*ist Feld schon in Hashtabelle?*/
		    if (Loesungstabelle_sol.containsKey(hash(Feld)))
			{
			    LinkedList temp = (LinkedList) Loesungstabelle_sol.get(hash(Feld));
			    Loesung = (LinkedList) temp.clone();
			}

		    /*ansonsten muss Server gestartet werden.*/
		    else
			{
			    String string;
			    StringBuffer s = new StringBuffer();

			    remove(Start);
			    remove(Zurueck);
			    remove(ReConfig);

			    th.start();

                	    string = Connection("loesung_sol " + hash(Feld));
			    s = new StringBuffer(string);
			    
                            /*Parser des Strings s.*/
                            while ( (s.length()) > 0)
                            {
                                Felder[0][0] = (int) s.charAt(0) - 48;
                                Felder[0][1] = (int) s.charAt(1) - 48;
                                Felder[1][0] = (int) s.charAt(3) - 48;
                                Felder[1][1] = (int) s.charAt(4) - 48;
                                Felder[2][0] = (int) s.charAt(6) - 48;
                                Felder[2][1] = (int) s.charAt(7) - 48;

                                s.delete(0, 9);
                                Loesung.add(Felder);
                                Felder = new int[3][2];
                            }

                            Loesungstabelle_sol.put(hash(Feld), Loesung.clone());
		         }

		    if (Loesung.isEmpty())
			{fertig = true;}
                    else
                       {
		       Felder = (int[][]) Loesung.getFirst();

		       if ( (Felder[0][0] == 0) && (Felder[0][1] == 0) && (Felder[1][0] == 0) &&
			    (Felder[1][1] == 0) && (Felder[2][0] == 0) && (Felder[2][1] == 0))
			   {keine_loesung = true;}
		       else
			   {
			       loesung_existiert = true;
			       add(Vor);
			       add(AutoLauf);
			       ChTempo.setVisible(true);
			   }
		       }
		    add(Start);
		    add(Zurueck);
		    add(ReConfig);

		    th.stoppe();

		    dialog.setVisible(false);
                    }

		             catch (MalformedURLException error)
			        {
				    add(Start);
				    add(Zurueck);
				    add(ReConfig);
				    dialog.setVisible(false);
				    nohost = true;
				    noconnection = false;
				    fertig = false;
				    keine_loesung = false;
				    loesung_existiert = false;
				    th.stoppe();
				    dialog.setVisible(false);
				    dialog_noconnection.setVisible(true);
				}
		             catch (IOException error)
				{
				    add(Start);
				    add(Zurueck);
				    add(ReConfig);
				    dialog.setVisible(false);
				    nohost = false;
				    noconnection = true;
				    fertig = false;
				    keine_loesung = false;
				    loesung_existiert = false;
				    th.stoppe();
				    dialog.setVisible(false);
				    dialog_noconnection.setVisible(true);
				}
		    }

				
                if (e.getSource() == Vor)
		    {	
			if(!Loesung.isEmpty()){
				AutoL = false;
				CDarf= true;
				be = true;
			}
                    }

		if (e.getSource() == AutoLauf){
			if (AutoL){
				AutoL = false;
				AutoLauf.setLabel("Show solution");
				CDarf = false;
				add(Vor);
				add(ReConfig);
				add(Start);
				add(Zurueck);
				add(Pruefung);
				FeldClear();
			}else{
				AutoL = true;
				ConfigAufbau = true;
				AutoLauf.setLabel("Stop");
				remove(Vor);
				remove(ReConfig);
				remove(Start);
				remove(Zurueck);
				remove(Pruefung);
				
				if (!Loesung.isEmpty()){
					CDarf = true;
					be = true;
				}
			}
		}


		nowX = 7;
		nowY = 7;
		//Bezugspunkte lschen

		repaint();
	}

    public void itemStateChanged(ItemEvent e)
    {
    }


    private void Bild_Laden()
    {
	background = getImage(getDocumentBase(),getParameter("background"));
	SteinImage = getImage(getDocumentBase(),getParameter("Stein"));
	UsetStein = getImage(getDocumentBase(),getParameter("UStein"));
        MarkedStein = getImage(getDocumentBase(),getParameter("Markiert"));
	Pud = getImage(getDocumentBase(),getParameter("Pfeilud"));
	Prl = getImage(getDocumentBase(),getParameter("Pfeilrl"));


	MediaTracker mt = new MediaTracker(this);
	mt.addImage(background, 0);
	mt.addImage(SteinImage, 0);
	mt.addImage(UsetStein, 0);
	mt.addImage(MarkedStein, 0);
	mt.addImage(Pud, 0);
	mt.addImage(Prl, 0);

        try
	    {
		//Warten bis das Image vollstndig geladen ist
		mt.waitForAll();
	    }
	catch (InterruptedException e) {}

    }

    //Untersucht verschiedene Sachen
    private void Untersuchung()
    {
		if (CDarf) //Anzeige nchster Zug

		    		if(!Loesung.isEmpty()){
	 				Felder = (int[][]) Loesung.getFirst(); 

					if (be){
						FeldUmarkieren();		    
						TM(Felder);be=false;
					}
					else {
						computerzug(Felder);
						be=true;
						if (!AutoL)
							CDarf=false;
					}
				}

		if (AutoL && !fertig)
			repaint();

		if (fertig && ConfigAufbau){
			AutoLauf.setLabel("Play solution");
			add(Start);
			add(ReConfig);
			add(Zurueck);
			add(Pruefung);
			ConfigAufbau = false;
		}

		dialog_menschgewonnen.setVisible(menschgewonnen);

    }

class Zeitzaehlthread
extends Thread
{
    boolean darf = true;

    public Zeitzaehlthread()
    {}

    public void stoppe()
    {
	this.darf = false;
    }

    public void run()
    {
	while (darf)
	    {
		dialog.setVisible(darf);

		try{
		    Thread.sleep(1000);
			}
		catch (InterruptedException e)
		    {}

		dauer++;
		dialog.removeAll();
		dialog.setLayout(new GridLayout(3, 1));
		dialog.add(new Label("Computing a solution. Please wait..."));
		dialog.add(new Label("Time: " + dauer + " seconds"));
	    }

	dialog.setVisible(false);

	dauer = 0;
	dialog.removeAll();
	dialog.setLayout(new GridLayout(3, 1));
	dialog.add(new Label("Computing a solution. Please wait..."));
	dialog.add(new Label("Time: " + dauer + " seconds"));
    }

}

}
