//Autor: Peter Reimann
//Datum: 06.07.2004
//Programmiersprache: Java2 1.4
//Beschreibung: Dieses Programm berechnet die Lsung fr das Schiebespiel.
//              Es wird vom Serverprogramm gestartet und bekommt die
//              Spielfeldkonfiguration ber die Kommandozeile.
//              Zunchst wird mit Hilfe der Inversionszahl des Feldes geprft,
//              ob es berhaupt eine Lsung gibt. Gibt es eine Lsung,
//              dann setzt es in den Dateien fr die einzelnen Durchlufe
//              dem entsprechend die Anfangsmarkierung, ruft damit den Checker
//              auf und gibt die Lsungszge aus.
//Die senil- und formDateien befinden sich im Unterverzeichnis files

import java.io.*;
import java.util.*;

class loesung_schiebe
{
    //Strings die fr die Pfadangaben bentigt werden
    private final static String kit_path = config.topdir + "mckit/bin/";
    private final static String schiebe_path = config.topdir +  "files/";
    private final static String checker = "check senil:lola-reach -o bf ";//Leerzeichen sind wichtig
    private final static String senil_datei1 = "schiebe4x4-1.senil";
    private final static String form_datei1 = "schiebe4x4-1.form";
    private final static String senil_datei2 = "schiebe4x4-2.senil";
    private final static String form_datei2 = "schiebe4x4-2.form";
    private final static String senil_datei3 = "schiebe4x4-3.senil";
    private final static String form_datei3 = "schiebe4x4-3.form";
    private final static String senil_datei4 = "schiebe3x3-1.senil";
    private final static String form_datei4 = "schiebe3x3-1.form";
    private final static String senil_datei5 = "schiebe3x3-2.senil";
    private final static String form_datei5 = "schiebe3x3-2.form";


  static int Feld[][] = new int[4][4];

  private static LinkedList Zuege = new LinkedList();


  /*Setzt die Anfangsmarkierung, ruft den Checker fr den ersten Durchlauf
    auf und speichert dessen Ergebnis in eine Liste.*/  

  private static LinkedList check1(int Feld[][]) throws IOException 
  {
    StringBuffer marking = new StringBuffer();
    RandomAccessFile f = new RandomAccessFile(schiebe_path + senil_datei1, "rw");
    StringBuffer Ausgabe = new StringBuffer();
    StringBuffer Puffer = new StringBuffer();
    LinkedList Transitionen = new LinkedList();

    if ((Feld[0][0] == 1) && (Feld[0][3] == 4) && (Feld[3][0] == 13))
      return Transitionen;

    for (int i = 0; i < 4; i++)
    {
    for (int j = 0; j < 4; j++)
      {
      marking.append((char) (65 + j));
      marking.append(i + 1);
      if (Feld[i][j] == 0)
        {marking.append("loch, ");}
      else
        { if (Feld[i][j] == 1)
            {marking.append("p1, ");}
          else
          { if (Feld[i][j] == 4)
              {marking.append("p4, ");}
            else
            { if (Feld[i][j] == 13)
                {marking.append("p13, ");}
              else
                {marking.append("x, ");}
            }
          }
        }
      }
    }
      /*in dieser Schleife wird die Anfangsmarkierung der senil-Datei
        in den StringBuffer marking gespeichert.*/

    marking.deleteCharAt(marking.length() - 2);
      /*Das Komma am Schluss von marking muss entfernt werden.*/

    f.setLength(7405);
      /*Die derzeitige Anfangsmarkierung in der senil-Datei wird gelscht.*/
    f.seek(7405);
    f.writeBytes(marking.toString());
      /*Der Inhalt von marking wird ans Ende der Senil-Datei geschrieben.
        Dadurch ist die Anfangsmarkierung in der Datei gesetzt.*/
    
    Process p = Runtime.getRuntime().exec(kit_path + checker + schiebe_path + senil_datei1 + " " + schiebe_path + form_datei1);
         /* Checker wird gestartet */

    BufferedReader IN = new BufferedReader(
                        new InputStreamReader(p.getInputStream()) );
         /* Ausgabe des Checkers wird in IN gespeichert */

     while ( !((Ausgabe.toString().equals("Result: YES.")) || (Ausgabe.toString().equals("Result: NO."))))
      {Ausgabe = new StringBuffer(IN.readLine());}

     if (Ausgabe.toString().equals("Result: YES."))
     { Ausgabe = new StringBuffer(IN.readLine());
       Ausgabe = Ausgabe.delete(0,9);
       /*existiert eine Lsung wird diese in den StringBuffer Ausgabe geschrieben.*/

    for (int i = 0; i < Ausgabe.length(); i++)
         {if (Ausgabe.charAt(i) == ',')
            {Transitionen.add(Puffer);
             Puffer = new StringBuffer();
            }
          else
            {if (Ausgabe.charAt(i) == ' ')
               {;}
             else
               {Puffer = Puffer.append(Ausgabe.charAt(i));}
            }
         }
       Transitionen.add(Puffer);
      /*In dieser Schleife wird Ausgabe Zeichen fr Zeichen gelesen
        und die einzelnen Transitionen in die Liste Transitionen gespeichert,
        die in den nchsten Anweisungen zurckgegeben wird.*/

     }
     else
     { Transitionen.add("geht nicht");} //es gibt keine Lsung

     return Transitionen;
  }


 /*Setzt die Anfangsmarkierung, ruft den Checker fr den zweiten Durchlauf
    auf und speichert dessen Ergebnis in eine Liste.*/  

  private static LinkedList check2(int Feld[][]) throws IOException 
  {
    StringBuffer marking = new StringBuffer();
    RandomAccessFile f = new RandomAccessFile(schiebe_path + senil_datei2, "rw");
    StringBuffer Ausgabe = new StringBuffer();
    StringBuffer Puffer = new StringBuffer();
    LinkedList Transitionen = new LinkedList();

    if ((Feld[0][1] == 2) && (Feld[0][2] == 3))
      return Transitionen;

    for (int i = 0; i < 4; i++)
    {
    for (int j = 0; j < 4; j++)
      {
      marking.append((char) (65 + j));
      marking.append(i + 1);
      if (Feld[i][j] == 0)
        {marking.append("loch, ");}
      else
        { if (Feld[i][j] == 2)
            {marking.append("p2, ");}
          else
          { if (Feld[i][j] == 3)
              {marking.append("p3, ");}
            else
              {marking.append("x, ");}
          }
        }
      }
    }
      /*in dieser Schleife wird die Anfangsmarkierung der senil-Datei
        in den StringBuffer marking gespeichert.*/

    marking.deleteCharAt(marking.length() - 2);
      /*Das Komma am Schluss von marking muss entfernt werden.*/

    f.setLength(4093);
      /*Die derzeitige Anfangsmarkierung in der senil-Datei wird gelscht.*/
    f.seek(4093);
    f.writeBytes(marking.toString());
      /*Der Inhalt von marking wird ans Ende der Senil-Datei geschrieben.
        Dadurch ist die Anfangsmarkierung in der Datei gesetzt.*/
    
    Process p = Runtime.getRuntime().exec(kit_path + checker + schiebe_path + senil_datei2 + " " + schiebe_path + form_datei2);
         /* Checker wird gestartet */

    BufferedReader IN = new BufferedReader(
                        new InputStreamReader(p.getInputStream()) );
         /* Ausgabe des Checkers wird in IN gespeichert */

     while ( !((Ausgabe.toString().equals("Result: YES.")) || (Ausgabe.toString().equals("Result: NO."))))
      {Ausgabe = new StringBuffer(IN.readLine());}

     if (Ausgabe.toString().equals("Result: YES."))
     { Ausgabe = new StringBuffer(IN.readLine());
       Ausgabe = Ausgabe.delete(0,9);
       /*existiert eine Lsung wird diese in den StringBuffer Ausgabe geschrieben.*/

    for (int i = 0; i < Ausgabe.length(); i++)
         {if (Ausgabe.charAt(i) == ',')
            {Transitionen.add(Puffer);
             Puffer = new StringBuffer();
            }
          else
            {if (Ausgabe.charAt(i) == ' ')
               {;}
             else
               {Puffer = Puffer.append(Ausgabe.charAt(i));}
            }
         }
       Transitionen.add(Puffer);
      /*In dieser Schleife wird Ausgabe Zeichen fr Zeichen gelesen
        und die einzelnen Transitionen in die Liste Transitionen gespeichert,
        die in den nchsten Anweisungen zurckgegeben wird.*/

     }
     else
     { Transitionen.add("geht nicht");} //es gibt keine Lsung

     return Transitionen;
  }


 /*Setzt die Anfangsmarkierung, ruft den Checker fr den dritten Durchlauf
    auf und speichert dessen Ergebnis in eine Liste.*/  

  private static LinkedList check3(int Feld[][]) throws IOException 
  {
    StringBuffer marking = new StringBuffer();
    RandomAccessFile f = new RandomAccessFile(schiebe_path + senil_datei3, "rw");
    StringBuffer Ausgabe = new StringBuffer();
    StringBuffer Puffer = new StringBuffer();
    LinkedList Transitionen = new LinkedList();

    if ((Feld[1][0] == 5) && (Feld[2][0] == 9))
      return Transitionen;

    for (int i = 1; i < 4; i++)
    {
    for (int j = 0; j < 4; j++)
      {
      marking.append((char) (65 + j));
      marking.append(i + 1);
      if (Feld[i][j] == 0)
        {marking.append("loch, ");}
      else
        { if (Feld[i][j] == 5)
            {marking.append("p5, ");}
          else
          { if (Feld[i][j] == 9)
              {marking.append("p9, ");}
            else
              {marking.append("x, ");}
          }
        }
      }
    }
      /*in dieser Schleife wird die Anfangsmarkierung der senil-Datei
        in den StringBuffer marking gespeichert.*/

    marking.deleteCharAt(marking.length() - 2);
      /*Das Komma am Schluss von marking muss entfernt werden.*/

    f.setLength(3406);
      /*Die derzeitige Anfangsmarkierung in der senil-Datei wird gelscht.*/
    f.seek(3406);
    f.writeBytes(marking.toString());
      /*Der Inhalt von marking wird ans Ende der Senil-Datei geschrieben.
        Dadurch ist die Anfangsmarkierung in der Datei gesetzt.*/
    
    Process p = Runtime.getRuntime().exec(kit_path + checker + schiebe_path + senil_datei3 + " " + schiebe_path + form_datei3);
         /* Checker wird gestartet */

    BufferedReader IN = new BufferedReader(
                        new InputStreamReader(p.getInputStream()) );
         /* Ausgabe des Checkers wird in IN gespeichert */

     while ( !((Ausgabe.toString().equals("Result: YES.")) || (Ausgabe.toString().equals("Result: NO."))))
      {Ausgabe = new StringBuffer(IN.readLine());}

     if (Ausgabe.toString().equals("Result: YES."))
     { Ausgabe = new StringBuffer(IN.readLine());
       Ausgabe = Ausgabe.delete(0,9);
       /*existiert eine Lsung wird diese in den StringBuffer Ausgabe geschrieben.*/

    for (int i = 0; i < Ausgabe.length(); i++)
         {if (Ausgabe.charAt(i) == ',')
            {Transitionen.add(Puffer);
             Puffer = new StringBuffer();
            }
          else
            {if (Ausgabe.charAt(i) == ' ')
               {;}
             else
               {Puffer = Puffer.append(Ausgabe.charAt(i));}
            }
         }
       Transitionen.add(Puffer);
      /*In dieser Schleife wird Ausgabe Zeichen fr Zeichen gelesen
        und die einzelnen Transitionen in die Liste Transitionen gespeichert,
        die in den nchsten Anweisungen zurckgegeben wird.*/

     }
     else
     { Transitionen.add("geht nicht");} //es gibt keine Lsung

     return Transitionen;
  }


 /*Setzt die Anfangsmarkierung, ruft den Checker fr den vierten Durchlauf
    auf und speichert dessen Ergebnis in eine Liste.*/  

  private static LinkedList check4(int Feld[][]) throws IOException 
  {
    StringBuffer marking = new StringBuffer();
    RandomAccessFile f = new RandomAccessFile(schiebe_path + senil_datei4, "rw");
    StringBuffer Ausgabe = new StringBuffer();
    StringBuffer Puffer = new StringBuffer();
    LinkedList Transitionen = new LinkedList();

    if ((Feld[1][1] == 6) && (Feld[1][2] == 7) && (Feld[1][3] == 8))
      return Transitionen;

    for (int i = 1; i < 4; i++)
    {
    for (int j = 1; j < 4; j++)
      {
      marking.append((char) (65 + j));
      marking.append(i + 1);
      if (Feld[i][j] == 0)
        {marking.append("loch, ");}
      else
        { if (Feld[i][j] == 6)
            {marking.append("p6, ");}
          else
          { if (Feld[i][j] == 7)
              {marking.append("p7, ");}
            else
            { if (Feld[i][j] == 8)
                {marking.append("p8, ");}
              else
                {marking.append("x, ");}
            }
          }
        }
      }
    }
      /*in dieser Schleife wird die Anfangsmarkierung der senil-Datei
        in den StringBuffer marking gespeichert.*/

    marking.deleteCharAt(marking.length() - 2);
      /*Das Komma am Schluss von marking muss entfernt werden.*/

    f.setLength(3640);
      /*Die derzeitige Anfangsmarkierung in der senil-Datei wird gelscht.*/
    f.seek(3640);
    f.writeBytes(marking.toString());
      /*Der Inhalt von marking wird ans Ende der Senil-Datei geschrieben.
        Dadurch ist die Anfangsmarkierung in der Datei gesetzt.*/
    
    Process p = Runtime.getRuntime().exec(kit_path + checker + schiebe_path + senil_datei4 + " " + schiebe_path + form_datei4);
         /* Checker wird gestartet */

    BufferedReader IN = new BufferedReader(
                        new InputStreamReader(p.getInputStream()) );
         /* Ausgabe des Checkers wird in IN gespeichert */

     while ( !((Ausgabe.toString().equals("Result: YES.")) || (Ausgabe.toString().equals("Result: NO."))))
      {Ausgabe = new StringBuffer(IN.readLine());}

     if (Ausgabe.toString().equals("Result: YES."))
     { Ausgabe = new StringBuffer(IN.readLine());
       Ausgabe = Ausgabe.delete(0,9);
       /*existiert eine Lsung wird diese in den StringBuffer Ausgabe geschrieben.*/

    for (int i = 0; i < Ausgabe.length(); i++)
         {if (Ausgabe.charAt(i) == ',')
            {Transitionen.add(Puffer);
             Puffer = new StringBuffer();
            }
          else
            {if (Ausgabe.charAt(i) == ' ')
               {;}
             else
               {Puffer = Puffer.append(Ausgabe.charAt(i));}
            }
         }
       Transitionen.add(Puffer);
      /*In dieser Schleife wird Ausgabe Zeichen fr Zeichen gelesen
        und die einzelnen Transitionen in die Liste Transitionen gespeichert,
        die in den nchsten Anweisungen zurckgegeben wird.*/

     }
     else
     { Transitionen.add("geht nicht");} //es gibt keine Lsung

     return Transitionen;
  }


 /*Setzt die Anfangsmarkierung, ruft den Checker fr den fnften Durchlauf
    auf und speichert dessen Ergebnis in eine Liste.*/  

  private static LinkedList check5(int Feld[][]) throws IOException 
  {
    StringBuffer marking = new StringBuffer();
    RandomAccessFile f = new RandomAccessFile(schiebe_path + senil_datei5, "rw");
    StringBuffer Ausgabe = new StringBuffer();
    StringBuffer Puffer = new StringBuffer();
    LinkedList Transitionen = new LinkedList();

    if ((Feld[1][1] == 6) && (Feld[1][2] == 7) && (Feld[1][3] == 8) && (Feld[2][1] == 10) && (Feld[2][2] == 11) && (Feld[2][3] == 12) && (Feld[3][1] == 14) && (Feld[3][2] == 15) && (Feld[3][3] == 0))
      return Transitionen;

    for (int i = 1; i < 4; i++)
    {
    for (int j = 1; j < 4; j++)
      {
      marking.append((char) (65 + j));
      marking.append(i + 1);
      if (Feld[i][j] == 0)
        {marking.append("loch, ");}
      else
        { if (Feld[i][j] == 6)
            {marking.append("p6, ");}
          else
          { if (Feld[i][j] == 7)
              {marking.append("p7, ");}
            else
            { if (Feld[i][j] == 8)
                {marking.append("p8, ");}
              else
              { if (Feld[i][j] == 9)
                  {marking.append("p9, ");}
                else
                { if (Feld[i][j] == 10)
                    {marking.append("p10, ");}
                  else
                  { if (Feld[i][j] == 11)
                    {marking.append("p11, ");}
                    else
                    { if (Feld[i][j] == 12)
                      {marking.append("p12, ");}
                      else
                      { if (Feld[i][j] == 13)
                        {marking.append("p13, ");}
                        else
                        { if (Feld[i][j] == 14)
                          {marking.append("p14, ");}
                          else
                          { if (Feld[i][j] == 15)
                            {marking.append("p15, ");}
                 
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
      /*in dieser Schleife wird die Anfangsmarkierung der senil-Datei
        in den StringBuffer marking gespeichert.*/

    marking.deleteCharAt(marking.length() - 2);
      /*Das Komma am Schluss von marking muss entfernt werden.*/

    f.setLength(7525);
      /*Die derzeitige Anfangsmarkierung in der senil-Datei wird gelscht.*/
    f.seek(7525);
    f.writeBytes(marking.toString());
      /*Der Inhalt von marking wird ans Ende der Senil-Datei geschrieben.
        Dadurch ist die Anfangsmarkierung in der Datei gesetzt.*/

 
    Process p = Runtime.getRuntime().exec(kit_path + checker + schiebe_path + senil_datei5 + " " + schiebe_path + form_datei5);
         /* Checker wird mit lola-stub-bf-reach gestartet */

    BufferedReader IN = new BufferedReader(
                        new InputStreamReader(p.getInputStream()));
         /* Ausgabe des Checkers wird in IN gespeichert */


    Ausgabe = new StringBuffer(IN.readLine());

     while ( !((Ausgabe.toString().equals("Result: YES.")) || (Ausgabe.toString().equals("Result: NO."))))
      { Ausgabe = new StringBuffer(IN.readLine());}

     if (Ausgabe.toString().equals("Result: YES."))
     { Ausgabe = new StringBuffer(IN.readLine());
       Ausgabe = Ausgabe.delete(0,9);
       /*existiert eine Lsung wird diese in den StringBuffer Ausgabe geschrieben.*/

    for (int i = 0; i < Ausgabe.length(); i++)
         {if (Ausgabe.charAt(i) == ',')
            {Transitionen.add(Puffer);
             Puffer = new StringBuffer();
            }
          else
            {if (Ausgabe.charAt(i) == ' ')
               {;}
             else
               {Puffer = Puffer.append(Ausgabe.charAt(i));}
            }
         }
       Transitionen.add(Puffer);
      /*In dieser Schleife wird Ausgabe Zeichen fr Zeichen gelesen
        und die einzelnen Transitionen in die Liste Transitionen gespeichert,
        die in den nchsten Anweisungen zurckgegeben wird.*/

     }
     else 
     { Transitionen.add("geht nicht");} //es gibt keine Lsung(nur zur Sicherung)
     
     return Transitionen;
   }


  /*Die Funktion simuliere, simuliert mit Hilfe einer Transitionenliste das Ergebnis eines
    Durchlaufs durch, damit man danach den nchsten Durchlauf starten kann. In Datei steht
    dabei die entsprechende Senildatei des Durchlaufes. Desweiteren werden die Zahlenpaare
    der Zge in die globale Liste Zuege gespeichert.*/

  private static int[][] simuliere(int Feld[][], LinkedList Liste, String Datei) throws IOException
  {
    RandomAccessFile f = new RandomAccessFile(Datei, "rw");
    String Zeile = f.readLine();
    LinkedList Loesung = (LinkedList) Liste.clone();
    int temp; //wird zum Tauschen der Elemente gebraucht.
    int Felder[][] = new int[2][2];

    while (!(Loesung.isEmpty()))
    {     while (!(Zeile.regionMatches(17, Loesung.getFirst().toString(), 0, (Loesung.getFirst().toString()).length())))
          {Zeile = f.readLine();}

      Felder[0][0] = (int) Zeile.charAt(1) - 49;
      Felder[0][1] = (int) Zeile.charAt(0) - 65;
      Felder[1][0] = (int) Zeile.charAt(9) - 49;
      Felder[1][1] = (int) Zeile.charAt(8) - 65;

      Zuege.add(Felder);  

      temp = Feld[Felder[1][0]][Felder[1][1]];
      Feld[Felder[0][0]][Felder[0][1]] = temp;
      Feld[Felder[1][0]][Felder[1][1]] = 0;

      Felder = new int[2][2];
      Loesung.removeFirst();
      f.seek(0);
      Zeile = f.readLine();
    }
    return Feld;
  }


  /*Die "Hauptfunktion" des ganzen Programms. Sie berechnet mittels
    den Funktionen check den Lsungsweg. Danach ruft Sie, wenn ntig, die
    Simulation fr die einzelnen Durchlufe auf, und startet dann den nchsten Durchlauf
    Die Ausnahmebehandlung der IOException dient nur um den Compiler auszutricksen:-).*/


  public static void naechsterZug(int Spielfeld[][])
  {LinkedList Loesung[] = new LinkedList[5];
   boolean keine_loesung = false;
   int Feld[][] = new int[4][4];
   /*eine Tiefenkopie von Spielfeld wird in Feld gespeichert*/
   for (int i = 0; i < 4; i++)
   {
     Feld[i] = (int[]) Spielfeld[i].clone();
   }
    
    try
    {
	//Starten des ersten Durchlaufs
      Loesung[0] = check1(Feld);


        if (!(Loesung[0].isEmpty()) && (Loesung[0].getFirst().toString() ==  "geht nicht"))
        { keine_loesung = true;}
        else
        {
          Feld = simuliere(Feld, Loesung[0], schiebe_path + senil_datei1);
	  //Starten des zweiten Durchlaufs
          Loesung[1] = check2(Feld);

          if (!(Loesung[1].isEmpty()) && (Loesung[1].getFirst().toString() ==  "geht nicht"))
          { keine_loesung = true;}
          else
          {
            Feld = simuliere(Feld, Loesung[1], schiebe_path + senil_datei2);
	    //Starten des dritten Durchlaufs
            Loesung[2] = check3(Feld);

            if (!(Loesung[2].isEmpty()) && (Loesung[2].getFirst().toString() ==  "geht nicht"))
            { keine_loesung = true;}
            else
            {
              Feld = simuliere(Feld, Loesung[2], schiebe_path + senil_datei3);
	      //Starten des vierten Durchlaufs
              Loesung[3] = check4(Feld);

              if (!(Loesung[3].isEmpty()) && (Loesung[3].getFirst().toString() ==  "geht nicht"))
              { keine_loesung = true;}
              else
              {
                Feld = simuliere(Feld, Loesung[3], schiebe_path + senil_datei4);
		//Starten des fnften Durchlaufs
                Loesung[4] = check5(Feld);

                if (!(Loesung[4].isEmpty()) && (Loesung[4].getFirst().toString() ==  "geht nicht"))
                { keine_loesung = true;}
                else
                {
                  Feld = simuliere(Feld, Loesung[4], schiebe_path + senil_datei5);

                  /*eine Tiefenkopie von Spielfeld wird in Feld gespeichert*/
                  for (int i = 0; i < 4; i++)
                  {
                    Feld[i] = (int[]) Spielfeld[i].clone();
                  }

                }
              }
            }
          }
        }


      if (keine_loesung) // es existiert keine Lsung
      { int temp[][] = {{0,0},{0,0}};
        Zuege = new LinkedList();
        Zuege.add(temp);
      }

   
    }
    catch ( IOException e)    //Schreib-/ Leseprobleme
    {
      int temp[][] = {{9,9},{9,9},{9,9}};
      Zuege = new LinkedList();
      Zuege.add(temp); 
      System.out.println(e);
    }
  }


    //Berechnung der Inversionszahl, um zu bestimmen, ob es eine Lsung gibt
    private static int getInversion()
    {
	int inversion = 0;

      	for (int i = 0; i<=14; i++)
			{	
				
					for (int j = i+1; j <=15; j++)
					{
					
					if (Feld[i / 4][i - (4 * (i / 4))] != 0)
					{
						if (Feld[j / 4][j - (4 * (j / 4))] != 0)
						{
						  		
				    		if (Feld[i / 4][i - (4 * (i / 4))]> 
								Feld[j / 4][j - (4 * (j / 4))])
							{
								inversion++;
							}	
						}
					}
				}
			}

	return inversion;
    }

  
  public static void main(String args[])
  {
    int empty_x = 0; //Hier steht dann die x-Position des leeren Feldes
    int inversion;

    //Die Konfiguration aus der Kommandozeile wird in Feld gespeichert
    for (int i = 0; i < 4; i++)
    {
      for (int j = 0; j < 4; j++)
      {
         Feld[i][j] = Integer.parseInt(args[(i * 4) + j]);

         if (Feld[i][j] == 0)
            empty_x = i; //x-Position des leeren Feldes setzen

      }
    }

    inversion = getInversion(); //Inversionszahl fr das Feld berechnen

    int Felder2[][];  
        
    if (( (empty_x + 1) % 2) == (inversion % 2)) //es existiert eine Lsung
       naechsterZug(Feld);  //Berechnung der Lsung
    else //es existiert keine Lsung
       {
          int temp[][] = {{0,0},{0,0}};
          Zuege = new LinkedList();
          Zuege.add(temp);
       }

    //Ausgabe der Lsung    
    while (!(Zuege.isEmpty()))
    {
       Felder2 = (int[][]) Zuege.getFirst();
       Zuege.removeFirst();

       for (int i = 0; i < 2; i++)
       {
         for (int j = 0; j < 2; j++)
         {
           System.out.print(Felder2[i][j]);
         }
         if (i < 1)
           System.out.print("_");
       }
       System.out.print(";");
    }
    System.out.println();
 }

}
