//Autor: Peter Reimann
//Datum: 06.07.2004
//Programmiersprache: Java2 1.4
//Beschreibung: Dieses Programm berechnet die Lsung fr das Solitaire.
//              Es wird vom Serverprogramm gestartet und bekommt die
//              Spielfeldkonfiguration ber die Kommandozeile.
//              Es bestimmt dann zuerst mit Hilfe einer kleinen Gruppentheorie,
//              ob es eine Lsung gibt oder nicht. Gibt es eine Lsung,
//              dann setzt es in der Datei sol.senil dem enstprechend
//              die Anfangsmarkierung, ruft damit den Checker auf
//              und gibt die Lsungszge aus.
//Die Dateien sol.senil und sol.lt befinden sich im Unterverzeichnis files

import java.io.*;
import java.util.*;

class loesung_sol
{
    //Strings die fr die Pfadangaben bentigt werden
    private final static String kit_path = config.topdir +  "mckit/bin/";
    private final static String sol_path = config.topdir + "files/";
    private final static String checker = "check senil:spin-ltl "; //Leerzeichen sind wichtig!
    private final static String senil_datei = "sol.senil";
    private final static String ltl_datei = "sol.ltl";


  private static boolean Feld[][] = new boolean[7][7];

  //Werte, die dem Spielfeld entsprechend der Gruppe, die man braucht,
  //um zu bestimmen, ob es eine Lsung gibt, zugeordnet sind.
  // x = 1, y = 2, z = 3
  private static int Letters[][] = {{2, 3, 1, 2, 3, 1, 2},
                                    {3, 1, 2, 3, 1, 2, 3},
                                    {1, 2, 3, 1, 2, 3, 1},
                                    {2, 3, 1, 2, 3, 1, 2},
                                    {3, 1, 2, 3, 1, 2, 3},
                                    {1, 2, 3, 1, 2, 3, 1},
                                    {2, 3, 1, 2, 3, 1, 2}};

  private static LinkedList Zuege = new LinkedList();

  /*Setzt die Anfangsmarkierung, ruft den Checker auf und speichert
    dessen Ergebnis in eine Liste.*/  

  private static LinkedList check(boolean Feld[][]) throws IOException 
  {
    StringBuffer marking = new StringBuffer();
    RandomAccessFile f = new RandomAccessFile(sol_path + senil_datei, "rw");
    StringBuffer Ausgabe = new StringBuffer();
    StringBuffer Puffer = new StringBuffer(); //Zwischenspeicher
    LinkedList Transitionen = new LinkedList();


    for (int i = 0; i < 7; i++)
    {
    for (int j = 0; j < 7; j++)
      {
      marking.append((char) (65 + j));
      marking.append(i + 1);
      if (Feld[i][j])
        {marking.append("p,");}
      else
        {marking.append("n,");}
      }
    }
      /*in dieser Schleife wird die Anfangsmarkierung der senil-Datei
        in den StringBuffer marking gespeichert.*/

    marking.deleteCharAt(marking.length() - 1);
      /*Das Komma am Schluss von marking muss entfernt werden.*/
    f.setLength(2597);
      /*Die derzeitige Anfangsmarkierung in der senil-Datei wird gelscht.*/
    f.seek(2597);
    f.writeBytes(marking.toString());
      /*Der Inhalt von marking wird ans Ende der Senil-Datei geschrieben.
        Dadurch ist die Anfangsmarkierung in der Datei gesetzt.*/


    Process p = Runtime.getRuntime().exec(kit_path + checker + sol_path + senil_datei + " " + sol_path + ltl_datei);
         /* Checker wird gestartet */

    BufferedReader IN = new BufferedReader(
                        new InputStreamReader(p.getInputStream()) );
         /* Ausgabe des Checkers wird in IN gespeichert */

    IN.readLine();
    if (IN.readLine().toString().equals("Result: NO."))
      {Ausgabe = new StringBuffer(IN.readLine());
       Ausgabe = Ausgabe.delete(0,16);
       /*existiert eine Lsung wird diese in den StringBuffer Ausgabe geschrieben.*/

    for (int i = 0; i < Ausgabe.length(); i++)
         {if (Ausgabe.charAt(i) == ',')
            {Transitionen.add(Puffer);
             Puffer = new StringBuffer();
            }
          else
            {if (Ausgabe.charAt(i) == ' ')
               {;}
             else
               {Puffer = Puffer.append(Ausgabe.charAt(i));}
            }
         }
       Transitionen.add(Puffer);
      }
      /*In dieser Schleife wird Ausgabe Zeichen fr Zeichen gelesen
        und die einzelnen Transitionen in die Liste Transitionen gespeichert,
        die in den nchsten Anweisungen zurckgegeben wird.*/

    else
    { Transitionen.add("geht nicht");} //fr den Fall, dass es keine Lsung gibt.

    return Transitionen;
  }


  /*Die Funktion simuliere berechnet die Zahlenpaare der Felder, die verndert werden, Zug fr
    Zug und schreibt sie in die globale Liste Zge.*/

  private static void Simuliere(LinkedList Loesung, boolean Feld[][]) throws IOException
  {
    RandomAccessFile f = new RandomAccessFile(sol_path + senil_datei, "rw");
    String Zeile = f.readLine();
    int Felder[][] = new int[3][2];
  
    while (!(Loesung.isEmpty()))
    { 
  
    while (!(Zeile.regionMatches(15, Loesung.getFirst().toString(), 0, (Loesung.getFirst().toString()).length())))
      {Zeile = f.readLine();}

    Felder[0][0] = (int) Zeile.charAt(1) - 49;
    Felder[0][1] = (int) Zeile.charAt(0) - 65;
    Felder[1][0] = (int) Zeile.charAt(5) - 49;
    Felder[1][1] = (int) Zeile.charAt(4) - 65;
    Felder[2][0] = (int) Zeile.charAt(9) - 49;
    Felder[2][1] = (int) Zeile.charAt(8) - 65;

    Zuege.add(Felder);
    Felder = new int[3][2];

    Loesung.removeFirst();
    f.seek(0);
    Zeile = f.readLine();
    }

  }


  /*Die "Hauptfunktion" des ganzen Programms. Sie berechnet mittels
    den Funktionen check und simuliertden Lsungsweg.
    Die Ausnahmebehandlung der IOException dient nur um den Compiler auszutricksen:-).*/
   

  public static void naechsterZug(boolean Spielfeld[][])
  {LinkedList Loesung;
   boolean Feld[][] = new boolean[7][7];
   /*Das Spielfeld wird mit einer Tiefenkopie in Feld gespeichert.*/
   for (int i = 0; i < 7; i++)
   {
     Feld[i] = (boolean[]) Spielfeld[i].clone();
   }
    
    try
    {
        Loesung = check(Feld);

	if ((Loesung.getFirst().toString()) ==  "geht nicht") //es existiert keine Lsung
        {int temp[][] = {{0,0},{0,0},{0,0}};
	Zuege.add(temp);}
        else //eine Lsung existiert
        {Simuliere(Loesung, Feld);}
    }
    catch ( IOException e)    //Schreib-/ Leseprobleme
    {
      int temp[][] = {{9,9},{9,9},{9,9}};
      Zuege = new LinkedList();
      Zuege.add(temp); 
    }
  }


  //Die Addierfunktion fr die Gruppe, die man braucht, um zu bestimmen,
  //ob es eine Lsung gibt
  private static int add(int a, int b)
  {
     if ((a == b) || (a == 3) || (b == 3))
         return Math.abs(a - b);
     else
         return (a + b);
  }


  //Diese Funktion addiert die Werte aus der Gruppe der Felder,
  //die mit true belegt sind, auf. Ist das Ergebnis 2, dann gibt
  //es eine Lsung.
  private static int Feldsumme(boolean Feld[][])
  {
     int zwischensumme = 0;

     for (int i = 0; i < 7; i++)
        for (int j = 0; j < 7; j++)
             {
                 if (Feld[i][j])
                     zwischensumme = add(zwischensumme, Letters[i][j]);
             }

     return zwischensumme;
  }

  
  public static void main(String args[])
  {
    //Die Konfiguration aus der Kommandozeile wird in Feld gespeichert
    for (int i = 0; i < 7; i++)
    {
      for (int j = 0; j < 7; j++)
      {
         Feld[i][j] = (args[(i * 7) + j].equals("1"));

      }
    }

    int Felder2[][];   
        

    if (Feldsumme(Feld) == 2) //es existiert eine Lsung
       naechsterZug(Feld); //Berechnung der Lsung
    else  //es existier keine Lsung
       {
          Zuege = new LinkedList();
          int temp[][] = {{0,0},{0,0},{0,0}};
	  Zuege.add(temp);
       }

    //Ausgabe der Lsung
    while (!(Zuege.isEmpty()))
    {
       Felder2 = (int[][]) Zuege.getFirst();
       Zuege.removeFirst();
    
       for (int i = 0; i < 3; i++)
       {
         for (int j = 0; j < 2; j++)
         {
           System.out.print(Felder2[i][j]);
         }
         if (i < 2)
         System.out.print("_");
       }
       System.out.print(";");
    }
    System.out.println();
  }

}
